<?php
/* For licensing terms, see /license.txt */

namespace Chamilo\CoreBundle\Migrations\Schema\v2;

use Doctrine\DBAL\Schema\Schema;
use Oro\Bundle\MigrationBundle\Migration\Migration;
use Oro\Bundle\MigrationBundle\Migration\QueryBag;
use Oro\Bundle\MigrationBundle\Migration\OrderedMigrationInterface;

/**
 * Class Core
 * @package Chamilo\CoreBundle\Migrations\Schema\v2
 */
class Core implements Migration, OrderedMigrationInterface
{
    /**
     * {@inheritdoc}
     */
    public function getOrder()
    {
        return 1;
    }

    /**
     * @inheritdoc
     **/
    public function up(Schema $schema, QueryBag $queries)
    {
        $queries->addQuery("CREATE TABLE user (id INT AUTO_INCREMENT NOT NULL, username VARCHAR(255) NOT NULL, username_canonical VARCHAR(255) NOT NULL, enabled TINYINT(1) NOT NULL, salt VARCHAR(255) NOT NULL, password VARCHAR(255) NOT NULL, last_login DATETIME DEFAULT NULL, locked TINYINT(1) NOT NULL, expired TINYINT(1) NOT NULL, expires_at DATETIME DEFAULT NULL, confirmation_token VARCHAR(255) DEFAULT NULL, password_requested_at DATETIME DEFAULT NULL, roles LONGTEXT NOT NULL COMMENT '(DC2Type:array)', credentials_expired TINYINT(1) NOT NULL, credentials_expire_at DATETIME DEFAULT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, date_of_birth DATETIME DEFAULT NULL, firstname VARCHAR(64) DEFAULT NULL, lastname VARCHAR(64) DEFAULT NULL, website VARCHAR(64) DEFAULT NULL, biography VARCHAR(1000) DEFAULT NULL, gender VARCHAR(1) DEFAULT NULL, locale VARCHAR(8) DEFAULT NULL, timezone VARCHAR(64) DEFAULT NULL, phone VARCHAR(64) DEFAULT NULL, facebook_uid VARCHAR(255) DEFAULT NULL, facebook_name VARCHAR(255) DEFAULT NULL, facebook_data LONGTEXT DEFAULT NULL COMMENT '(DC2Type:json)', twitter_uid VARCHAR(255) DEFAULT NULL, twitter_name VARCHAR(255) DEFAULT NULL, twitter_data LONGTEXT DEFAULT NULL COMMENT '(DC2Type:json)', gplus_uid VARCHAR(255) DEFAULT NULL, gplus_name VARCHAR(255) DEFAULT NULL, gplus_data LONGTEXT DEFAULT NULL COMMENT '(DC2Type:json)', token VARCHAR(255) DEFAULT NULL, two_step_code VARCHAR(255) DEFAULT NULL, user_id INT DEFAULT NULL, auth_source VARCHAR(50) DEFAULT NULL, status INT DEFAULT NULL, official_code VARCHAR(40) DEFAULT NULL, picture_uri VARCHAR(250) DEFAULT NULL, creator_id INT DEFAULT NULL, competences LONGTEXT DEFAULT NULL, diplomas LONGTEXT DEFAULT NULL, openarea LONGTEXT DEFAULT NULL, teach LONGTEXT DEFAULT NULL, productions VARCHAR(250) DEFAULT NULL, chatcall_user_id INT DEFAULT NULL, chatcall_date DATETIME DEFAULT NULL, chatcall_text VARCHAR(50) DEFAULT NULL, language VARCHAR(40) DEFAULT NULL, registration_date DATETIME NOT NULL, expiration_date DATETIME DEFAULT NULL, active TINYINT(1) NOT NULL, openid VARCHAR(255) DEFAULT NULL, theme VARCHAR(255) DEFAULT NULL, hr_dept_id SMALLINT DEFAULT NULL, isActive VARCHAR(255) NOT NULL, email VARCHAR(255) NOT NULL, emailCanonical VARCHAR(255) NOT NULL, UNIQUE INDEX UNIQ_8D93D64992FC23A8 (username_canonical), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_accessurl (user_id INT NOT NULL, access_url_id INT NOT NULL, INDEX IDX_DD3D6AB5A76ED395 (user_id), INDEX IDX_DD3D6AB573444FD5 (access_url_id), PRIMARY KEY(user_id, access_url_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE jury_members (id INT AUTO_INCREMENT NOT NULL, jury_id INT DEFAULT NULL, user_id INT DEFAULT NULL, role_id INT DEFAULT NULL, INDEX IDX_CCB37077E560103C (jury_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE branch_transaction_data (id BIGINT AUTO_INCREMENT NOT NULL, data LONGTEXT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_online (login_id INT AUTO_INCREMENT NOT NULL, login_user_id INT NOT NULL, login_date DATETIME NOT NULL, login_ip VARCHAR(39) NOT NULL, course VARCHAR(40) DEFAULT NULL, session_id INT NOT NULL, access_url_id INT NOT NULL, INDEX login_user_id (login_user_id), INDEX course (course), INDEX session_id (session_id), INDEX idx_trackonline_uat (login_user_id, access_url_id, login_date), PRIMARY KEY(login_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE search_engine_ref (id INT AUTO_INCREMENT NOT NULL, course_code VARCHAR(40) NOT NULL, tool_id VARCHAR(100) NOT NULL, ref_id_high_level INT NOT NULL, ref_id_second_level INT DEFAULT NULL, search_did INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE promotion (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, career_id INT NOT NULL, status INT NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE promotion_audit (id INT NOT NULL, rev INT NOT NULL, career_id INT DEFAULT NULL, name VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, status INT DEFAULT NULL, created_at DATETIME DEFAULT NULL, updated_at DATETIME DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_module (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, link VARCHAR(255) NOT NULL, image VARCHAR(100) DEFAULT NULL, row_module INT NOT NULL, column_module INT NOT NULL, position VARCHAR(20) NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE groups (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, description VARCHAR(255) NOT NULL, picture_uri VARCHAR(255) NOT NULL, url VARCHAR(255) NOT NULL, visibility INT NOT NULL, updated_on VARCHAR(255) NOT NULL, created_on VARCHAR(255) NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_rel_user (id INT AUTO_INCREMENT NOT NULL, user_id INT DEFAULT NULL, c_id INT DEFAULT NULL, group_id INT DEFAULT NULL, relation_type INT NOT NULL, status INT NOT NULL, role VARCHAR(60) DEFAULT NULL, tutor_id INT DEFAULT NULL, sort INT DEFAULT NULL, user_course_cat INT DEFAULT NULL, legal_agreement INT DEFAULT NULL, INDEX IDX_92CFD9FEA76ED395 (user_id), INDEX IDX_92CFD9FE91D79BD3 (c_id), INDEX IDX_92CFD9FEFE54D947 (group_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_rel_user_audit (id INT NOT NULL, rev INT NOT NULL, user_id INT DEFAULT NULL, c_id INT DEFAULT NULL, group_id INT DEFAULT NULL, relation_type INT DEFAULT NULL, status INT DEFAULT NULL, role VARCHAR(60) DEFAULT NULL, tutor_id INT DEFAULT NULL, sort INT DEFAULT NULL, user_course_cat INT DEFAULT NULL, legal_agreement INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_rel_course (id INT AUTO_INCREMENT NOT NULL, id_session INT DEFAULT NULL, c_id INT DEFAULT NULL, nbr_users INT NOT NULL, INDEX IDX_12D110D3ED97CA4 (id_session), INDEX IDX_12D110D391D79BD3 (c_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_rel_course_audit (id INT NOT NULL, rev INT NOT NULL, id_session INT DEFAULT NULL, c_id INT DEFAULT NULL, nbr_users INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url_rel_session (id INT AUTO_INCREMENT NOT NULL, access_url_id INT NOT NULL, session_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE curriculum_item (id INT AUTO_INCREMENT NOT NULL, category_id INT NOT NULL, title VARCHAR(255) DEFAULT NULL, score INT NOT NULL, max_repeat INT NOT NULL, INDEX IDX_5A9A424112469DE2 (category_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE question_field (id INT AUTO_INCREMENT NOT NULL, field_type INT NOT NULL, field_variable VARCHAR(64) NOT NULL, field_display_text VARCHAR(64) DEFAULT NULL, field_default_value LONGTEXT DEFAULT NULL, field_order INT DEFAULT NULL, field_visible TINYINT(1) DEFAULT NULL, field_changeable TINYINT(1) DEFAULT NULL, field_filter TINYINT(1) DEFAULT NULL, tms DATETIME NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_result (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, evaluation_id INT NOT NULL, created_at DATETIME NOT NULL, score DOUBLE PRECISION DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE personal_agenda (id INT AUTO_INCREMENT NOT NULL, user INT DEFAULT NULL, title LONGTEXT DEFAULT NULL, text LONGTEXT DEFAULT NULL, date DATETIME DEFAULT NULL, enddate DATETIME DEFAULT NULL, course VARCHAR(255) DEFAULT NULL, parent_event_id INT DEFAULT NULL, all_day INT NOT NULL, INDEX idx_personal_agenda_user (user), INDEX idx_personal_agenda_parent (parent_event_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_field (id INT AUTO_INCREMENT NOT NULL, field_type INT NOT NULL, field_variable VARCHAR(64) NOT NULL, field_display_text VARCHAR(64) DEFAULT NULL, field_default_value LONGTEXT DEFAULT NULL, field_order INT DEFAULT NULL, field_visible TINYINT(1) DEFAULT NULL, field_changeable TINYINT(1) DEFAULT NULL, field_filter TINYINT(1) DEFAULT NULL, field_loggeable INT DEFAULT NULL, tms DATETIME NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_request (id INT AUTO_INCREMENT NOT NULL, code VARCHAR(40) NOT NULL, user_id INT NOT NULL, directory VARCHAR(40) DEFAULT NULL, db_name VARCHAR(40) DEFAULT NULL, course_language VARCHAR(20) DEFAULT NULL, title VARCHAR(250) DEFAULT NULL, description LONGTEXT DEFAULT NULL, category_code VARCHAR(40) DEFAULT NULL, tutor_name VARCHAR(200) DEFAULT NULL, visual_code VARCHAR(40) DEFAULT NULL, request_date DATETIME NOT NULL, objetives LONGTEXT DEFAULT NULL, target_audience LONGTEXT DEFAULT NULL, status INT NOT NULL, info INT NOT NULL, exemplary_content INT NOT NULL, UNIQUE INDEX code (code), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_request_audit (id INT NOT NULL, rev INT NOT NULL, code VARCHAR(40) DEFAULT NULL, user_id INT DEFAULT NULL, directory VARCHAR(40) DEFAULT NULL, db_name VARCHAR(40) DEFAULT NULL, course_language VARCHAR(20) DEFAULT NULL, title VARCHAR(250) DEFAULT NULL, description LONGTEXT DEFAULT NULL, category_code VARCHAR(40) DEFAULT NULL, tutor_name VARCHAR(200) DEFAULT NULL, visual_code VARCHAR(40) DEFAULT NULL, request_date DATETIME DEFAULT NULL, objetives LONGTEXT DEFAULT NULL, target_audience LONGTEXT DEFAULT NULL, status INT DEFAULT NULL, info INT DEFAULT NULL, exemplary_content INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE shared_survey_question_option (question_option_id INT AUTO_INCREMENT NOT NULL, question_id INT NOT NULL, survey_id INT NOT NULL, option_text LONGTEXT NOT NULL, sort INT NOT NULL, PRIMARY KEY(question_option_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE settings_current (id INT AUTO_INCREMENT NOT NULL, variable VARCHAR(255) DEFAULT NULL, subkey VARCHAR(255) DEFAULT NULL, type VARCHAR(255) DEFAULT NULL, category VARCHAR(255) DEFAULT NULL, selected_value VARCHAR(255) DEFAULT NULL, title VARCHAR(255) NOT NULL, comment VARCHAR(255) DEFAULT NULL, scope VARCHAR(50) DEFAULT NULL, subkeytext VARCHAR(255) DEFAULT NULL, access_url INT NOT NULL, access_url_changeable INT NOT NULL, access_url_locked INT NOT NULL, INDEX access_url (access_url), INDEX idx_settings_current_au_cat (access_url, category), UNIQUE INDEX unique_setting (variable, subkey, category, access_url), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE settings_current_audit (id INT NOT NULL, rev INT NOT NULL, variable VARCHAR(255) DEFAULT NULL, subkey VARCHAR(255) DEFAULT NULL, type VARCHAR(255) DEFAULT NULL, category VARCHAR(255) DEFAULT NULL, selected_value VARCHAR(255) DEFAULT NULL, title VARCHAR(255) DEFAULT NULL, comment VARCHAR(255) DEFAULT NULL, scope VARCHAR(50) DEFAULT NULL, subkeytext VARCHAR(255) DEFAULT NULL, access_url INT DEFAULT NULL, access_url_changeable INT DEFAULT NULL, access_url_locked INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB;");

        $queries->addQuery("CREATE TABLE gradebook_evaluation_type (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) DEFAULT NULL, external_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE grade_model (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, description LONGTEXT DEFAULT NULL, default_lowest_eval_exclude TINYINT(1) DEFAULT NULL, default_external_eval TINYINT(1) DEFAULT NULL, default_external_eval_prefix VARCHAR(140) DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup_rel_course (id INT AUTO_INCREMENT NOT NULL, usergroup_id INT NOT NULL, course_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_field_options (id INT AUTO_INCREMENT NOT NULL, field_id INT NOT NULL, option_value LONGTEXT DEFAULT NULL, option_display_text VARCHAR(64) DEFAULT NULL, option_order INT DEFAULT NULL, priority INT DEFAULT NULL, priority_message VARCHAR(255) DEFAULT NULL, tms DATETIME NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE skill_profile (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE personal_agenda_repeat (cal_id INT AUTO_INCREMENT NOT NULL, cal_type VARCHAR(20) DEFAULT NULL, cal_end INT DEFAULT NULL, cal_frequency INT DEFAULT NULL, cal_days VARCHAR(7) DEFAULT NULL, PRIMARY KEY(cal_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_evaluation (id INT AUTO_INCREMENT NOT NULL, name LONGTEXT NOT NULL, description LONGTEXT DEFAULT NULL, user_id INT NOT NULL, course_code VARCHAR(40) DEFAULT NULL, category_id INT DEFAULT NULL, created_at DATETIME NOT NULL, weight DOUBLE PRECISION NOT NULL, max DOUBLE PRECISION NOT NULL, visible INT NOT NULL, type VARCHAR(40) NOT NULL, locked INT NOT NULL, evaluation_type_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course (id INT AUTO_INCREMENT NOT NULL, title VARCHAR(250) DEFAULT NULL, code VARCHAR(40) NOT NULL, directory VARCHAR(40) DEFAULT NULL, course_language VARCHAR(20) DEFAULT NULL, description LONGTEXT DEFAULT NULL, category_code VARCHAR(40) DEFAULT NULL, visibility INT DEFAULT NULL, show_score INT DEFAULT NULL, tutor_name VARCHAR(200) DEFAULT NULL, visual_code VARCHAR(40) DEFAULT NULL, department_name VARCHAR(30) DEFAULT NULL, department_url VARCHAR(180) DEFAULT NULL, disk_quota BIGINT DEFAULT NULL, last_visit DATETIME DEFAULT NULL, last_edit DATETIME DEFAULT NULL, creation_date DATETIME DEFAULT NULL, expiration_date DATETIME DEFAULT NULL, target_course_code VARCHAR(40) DEFAULT NULL, subscribe TINYINT(1) DEFAULT NULL, unsubscribe TINYINT(1) DEFAULT NULL, registration_code VARCHAR(255) DEFAULT NULL, legal LONGTEXT DEFAULT NULL, activate_legal INT DEFAULT NULL, add_teachers_to_sessions_courses TINYINT(1) DEFAULT NULL, course_type_id INT DEFAULT NULL, UNIQUE INDEX UNIQ_169E6FB977153098 (code), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_audit (id INT NOT NULL, rev INT NOT NULL, title VARCHAR(250) DEFAULT NULL, code VARCHAR(40) DEFAULT NULL, directory VARCHAR(40) DEFAULT NULL, course_language VARCHAR(20) DEFAULT NULL, description LONGTEXT DEFAULT NULL, category_code VARCHAR(40) DEFAULT NULL, visibility INT DEFAULT NULL, show_score INT DEFAULT NULL, tutor_name VARCHAR(200) DEFAULT NULL, visual_code VARCHAR(40) DEFAULT NULL, department_name VARCHAR(30) DEFAULT NULL, department_url VARCHAR(180) DEFAULT NULL, disk_quota BIGINT DEFAULT NULL, last_visit DATETIME DEFAULT NULL, last_edit DATETIME DEFAULT NULL, creation_date DATETIME DEFAULT NULL, expiration_date DATETIME DEFAULT NULL, target_course_code VARCHAR(40) DEFAULT NULL, subscribe TINYINT(1) DEFAULT NULL, unsubscribe TINYINT(1) DEFAULT NULL, registration_code VARCHAR(255) DEFAULT NULL, legal LONGTEXT DEFAULT NULL, activate_legal INT DEFAULT NULL, add_teachers_to_sessions_courses TINYINT(1) DEFAULT NULL, course_type_id INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_tree (id INT AUTO_INCREMENT NOT NULL, parent_id INT DEFAULT NULL, tool_id INT NOT NULL, session_path_id INT NOT NULL, course_id INT DEFAULT NULL, session_id INT DEFAULT NULL, type VARCHAR(255) DEFAULT NULL, lft INT DEFAULT NULL, lvl INT DEFAULT NULL, rgt INT DEFAULT NULL, root INT DEFAULT NULL, INDEX IDX_714F5EF6727ACA70 (parent_id), INDEX IDX_714F5EF68F7B22CC (tool_id), INDEX IDX_714F5EF6CBB4D431 (session_path_id), INDEX IDX_714F5EF6591CC992 (course_id), INDEX IDX_714F5EF6613FECDF (session_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE question_score_name (id INT AUTO_INCREMENT NOT NULL, question_score_id INT DEFAULT NULL, name VARCHAR(255) NOT NULL, score VARCHAR(255) NOT NULL, description VARCHAR(255) NOT NULL, UNIQUE INDEX UNIQ_13EF60F832993751 (score), UNIQUE INDEX UNIQ_13EF60F86DE44026 (description), INDEX IDX_13EF60F871E3BA5D (question_score_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url_rel_user (id INT AUTO_INCREMENT NOT NULL, access_url_id INT NOT NULL, user_id INT NOT NULL, INDEX idx_access_url_rel_user_user (user_id), INDEX idx_access_url_rel_user_access_url (access_url_id), INDEX idx_access_url_rel_user_access_url_user (user_id, access_url_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE skill_rel_profile (id INT AUTO_INCREMENT NOT NULL, skill_id INT NOT NULL, profile_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE notification (id BIGINT AUTO_INCREMENT NOT NULL, dest_user_id INT NOT NULL, dest_mail VARCHAR(255) DEFAULT NULL, title VARCHAR(255) DEFAULT NULL, sender_id INT NOT NULL, content VARCHAR(255) DEFAULT NULL, send_freq SMALLINT DEFAULT NULL, created_at DATETIME NOT NULL, sent_at DATETIME DEFAULT NULL, INDEX mail_notify_sent_index (sent_at), INDEX mail_notify_freq_index (sent_at, send_freq, created_at), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE block (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, path VARCHAR(255) NOT NULL, controller VARCHAR(100) NOT NULL, active TINYINT(1) NOT NULL, UNIQUE INDEX path (path), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_course_ranking (id INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, session_id INT NOT NULL, url_id INT NOT NULL, accesses INT NOT NULL, total_score INT NOT NULL, users INT NOT NULL, creation_date DATETIME NOT NULL, INDEX idx_tcc_cid (c_id), INDEX idx_tcc_sid (session_id), INDEX idx_tcc_urlid (url_id), INDEX idx_tcc_creation_date (creation_date), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE event_sent (id INT AUTO_INCREMENT NOT NULL, user_from INT NOT NULL, user_to INT DEFAULT NULL, event_type_name VARCHAR(100) DEFAULT NULL, INDEX event_name_index (event_type_name), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE branch_transaction_status (id INT AUTO_INCREMENT NOT NULL, title VARCHAR(20) DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_attempt_coeff (id INT AUTO_INCREMENT NOT NULL, attempt_id INT NOT NULL, marks_coeff DOUBLE PRECISION DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup_rel_question (id INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, question_id INT NOT NULL, usergroup_id INT NOT NULL, coefficient DOUBLE PRECISION DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE extra_field_option_rel_field_option (id INT AUTO_INCREMENT NOT NULL, field_id INT DEFAULT NULL, field_option_id INT DEFAULT NULL, related_field_option_id INT DEFAULT NULL, role_id INT DEFAULT NULL, UNIQUE INDEX idx (field_id, role_id, field_option_id, related_field_option_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE shared_survey_question (question_id INT AUTO_INCREMENT NOT NULL, survey_id INT NOT NULL, survey_question LONGTEXT NOT NULL, survey_question_comment LONGTEXT NOT NULL, type VARCHAR(250) NOT NULL, display VARCHAR(10) NOT NULL, sort INT NOT NULL, code VARCHAR(40) NOT NULL, max_value INT NOT NULL, PRIMARY KEY(question_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_category (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(100) DEFAULT NULL, date_start DATE DEFAULT NULL, date_end DATE DEFAULT NULL, access_url_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_category_audit (id INT NOT NULL, rev INT NOT NULL, access_url_id INT DEFAULT NULL, name VARCHAR(100) DEFAULT NULL, date_start DATE DEFAULT NULL, date_end DATE DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_category (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(100) NOT NULL, code VARCHAR(40) NOT NULL, parent_id VARCHAR(40) DEFAULT NULL, tree_pos INT DEFAULT NULL, children_count SMALLINT DEFAULT NULL, auth_course_child VARCHAR(100) DEFAULT NULL, auth_cat_child VARCHAR(100) DEFAULT NULL, INDEX parent_id (parent_id), INDEX tree_pos (tree_pos), UNIQUE INDEX code (code), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_category_audit (id INT NOT NULL, rev INT NOT NULL, parent_id INT DEFAULT NULL, name VARCHAR(100) DEFAULT NULL, code VARCHAR(40) DEFAULT NULL, tree_pos INT DEFAULT NULL, children_count SMALLINT DEFAULT NULL, auth_course_child VARCHAR(100) DEFAULT NULL, auth_cat_child VARCHAR(100) DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_linkeval_log (id INT AUTO_INCREMENT NOT NULL, id_linkeval_log INT NOT NULL, name LONGTEXT DEFAULT NULL, description LONGTEXT DEFAULT NULL, created_at DATETIME NOT NULL, weight SMALLINT DEFAULT NULL, visible TINYINT(1) DEFAULT NULL, type VARCHAR(20) NOT NULL, user_id_log INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE tag (id INT AUTO_INCREMENT NOT NULL, tag VARCHAR(255) NOT NULL, field_id INT NOT NULL, count INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_login (login_id INT AUTO_INCREMENT NOT NULL, login_user_id INT NOT NULL, login_date DATETIME NOT NULL, login_ip VARCHAR(39) NOT NULL, logout_date DATETIME DEFAULT NULL, INDEX login_user_id (login_user_id), PRIMARY KEY(login_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_field_options (id INT AUTO_INCREMENT NOT NULL, field_id INT NOT NULL, option_value LONGTEXT DEFAULT NULL, option_display_text VARCHAR(255) DEFAULT NULL, option_order INT DEFAULT NULL, priority INT DEFAULT NULL, priority_message VARCHAR(255) DEFAULT NULL, tms DATETIME NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url_rel_course (id INT AUTO_INCREMENT NOT NULL, c_id INT DEFAULT NULL, access_url_id INT DEFAULT NULL, INDEX IDX_8E97FC0891D79BD3 (c_id), INDEX IDX_8E97FC0873444FD5 (access_url_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url_rel_course_audit (id INT NOT NULL, rev INT NOT NULL, c_id INT DEFAULT NULL, access_url_id INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup_rel_usergroup (id INT AUTO_INCREMENT NOT NULL, group_id INT NOT NULL, subgroup_id INT NOT NULL, relation_type INT NOT NULL, INDEX usergroup_rel_usergroup_group_id (group_id), INDEX usergroup_rel_usergroup_subgroup_id (subgroup_id), INDEX usergroup_rel_usergroup_relation_type (relation_type), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE personal_agenda_repeat_not (cal_id INT NOT NULL, cal_date INT NOT NULL, PRIMARY KEY(cal_id, cal_date)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_api_key (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, api_key VARCHAR(32) NOT NULL, api_service VARCHAR(10) NOT NULL, api_end_point LONGTEXT DEFAULT NULL, created_date DATETIME DEFAULT NULL, validity_start_date DATETIME DEFAULT NULL, validity_end_date DATETIME DEFAULT NULL, description LONGTEXT DEFAULT NULL, INDEX idx_user_api_keys_user (user_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE career (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, status INT NOT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE career_audit (id INT NOT NULL, rev INT NOT NULL, name VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, status INT DEFAULT NULL, created_at DATETIME DEFAULT NULL, updated_at DATETIME DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE announcement_rel_group (id INT AUTO_INCREMENT NOT NULL, group_id INT NOT NULL, announcement_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_course_access (course_access_id BIGINT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, login_course_date DATETIME NOT NULL, logout_course_date DATETIME DEFAULT NULL, counter INT NOT NULL, session_id INT NOT NULL, c_id INT NOT NULL, INDEX user_id (user_id), INDEX login_course_date (login_course_date), INDEX c_id (c_id), INDEX session_id (session_id), PRIMARY KEY(course_access_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE question_score (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_rel_course_vote (id INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, user_id INT NOT NULL, session_id INT NOT NULL, url_id INT NOT NULL, vote INT NOT NULL, INDEX idx_ucv_cid (c_id), INDEX idx_ucv_uid (user_id), INDEX idx_ucv_cuid (user_id, c_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE specific_field (id INT AUTO_INCREMENT NOT NULL, code VARCHAR(1) NOT NULL, name VARCHAR(200) NOT NULL, UNIQUE INDEX unique_specific_field__code (code), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_uploads (upload_id INT AUTO_INCREMENT NOT NULL, upload_user_id INT DEFAULT NULL, upload_date DATETIME NOT NULL, upload_cours_id VARCHAR(40) NOT NULL, upload_work_id INT NOT NULL, upload_session_id INT NOT NULL, INDEX upload_user_id (upload_user_id), INDEX upload_cours_id (upload_cours_id), INDEX upload_session_id (upload_session_id), PRIMARY KEY(upload_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE branch_transaction (id BIGINT NOT NULL, transaction_id BIGINT NOT NULL, branch_id INT NOT NULL, action VARCHAR(20) DEFAULT NULL, item_id VARCHAR(36) DEFAULT NULL, dest_id VARCHAR(36) DEFAULT NULL, status_id TINYINT(1) NOT NULL, time_insert DATETIME NOT NULL, time_update DATETIME NOT NULL, PRIMARY KEY(id, transaction_id, branch_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_rel_course_rel_user (id INT AUTO_INCREMENT NOT NULL, id_session INT NOT NULL, c_id INT NOT NULL, id_user INT NOT NULL, visibility INT NOT NULL, status INT NOT NULL, legal_agreement INT DEFAULT NULL, INDEX idx_session_rel_course_rel_user_id_user (id_user), INDEX idx_session_rel_course_rel_user_course_id (c_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE system_template (id INT AUTO_INCREMENT NOT NULL, title VARCHAR(250) NOT NULL, comment LONGTEXT NOT NULL, image VARCHAR(250) NOT NULL, content LONGTEXT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE jury (id INT AUTO_INCREMENT NOT NULL, branch_id INT DEFAULT NULL, name VARCHAR(255) DEFAULT NULL, opening_date DATETIME DEFAULT NULL, closure_date DATETIME DEFAULT NULL, opening_user_id INT DEFAULT NULL, closure_user_id INT DEFAULT NULL, exercise_id INT NOT NULL, INDEX IDX_1335B02CDCD6CC49 (branch_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_rel_user (id BIGINT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, friend_user_id INT NOT NULL, relation_type INT NOT NULL, last_edit DATETIME DEFAULT NULL, INDEX idx_user_rel_user__user (user_id), INDEX idx_user_rel_user__friend_user (friend_user_id), INDEX idx_user_rel_user__user_friend_user (user_id, friend_user_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE event_email_template (id INT AUTO_INCREMENT NOT NULL, message LONGTEXT DEFAULT NULL, subject VARCHAR(255) DEFAULT NULL, event_type_name VARCHAR(255) DEFAULT NULL, activated TINYINT(1) NOT NULL, language_id INT DEFAULT NULL, INDEX event_name_index (event_type_name), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE language (id INT AUTO_INCREMENT NOT NULL, original_name VARCHAR(255) DEFAULT NULL, english_name VARCHAR(255) DEFAULT NULL, isocode VARCHAR(10) DEFAULT NULL, available TINYINT(1) NOT NULL, parent_id TINYINT(1) DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_field (id INT AUTO_INCREMENT NOT NULL, field_type INT NOT NULL, field_variable VARCHAR(64) NOT NULL, field_display_text VARCHAR(64) DEFAULT NULL, field_default_value LONGTEXT DEFAULT NULL, field_order INT DEFAULT NULL, field_visible TINYINT(1) DEFAULT NULL, field_changeable TINYINT(1) DEFAULT NULL, field_filter TINYINT(1) DEFAULT NULL, field_loggeable INT DEFAULT NULL, tms DATETIME NOT NULL, configuration LONGTEXT DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_field_audit (id INT NOT NULL, rev INT NOT NULL, field_type INT DEFAULT NULL, field_variable VARCHAR(64) DEFAULT NULL, field_display_text VARCHAR(64) DEFAULT NULL, field_default_value LONGTEXT DEFAULT NULL, field_order INT DEFAULT NULL, field_visible TINYINT(1) DEFAULT NULL, field_changeable TINYINT(1) DEFAULT NULL, field_filter TINYINT(1) DEFAULT NULL, field_loggeable INT DEFAULT NULL, tms DATETIME DEFAULT NULL, configuration LONGTEXT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_stored_values_stack (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, sco_id INT NOT NULL, stack_order INT NOT NULL, course_id VARCHAR(40) NOT NULL, sv_key VARCHAR(64) NOT NULL, sv_value LONGTEXT NOT NULL, UNIQUE INDEX user_id_2 (user_id, sco_id, course_id, sv_key, stack_order), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_attempt_jury (id INT AUTO_INCREMENT NOT NULL, exe_id INT DEFAULT NULL, question_id INT DEFAULT NULL, score DOUBLE PRECISION DEFAULT NULL, jury_member_id INT DEFAULT NULL, question_score_name_id INT DEFAULT NULL, INDEX IDX_977B4A18B5A18F57 (exe_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_field_values (id INT AUTO_INCREMENT NOT NULL, field_id INT NOT NULL, tms DATETIME NOT NULL, user_id VARCHAR(255) NOT NULL, comment VARCHAR(255) DEFAULT NULL, session_id INT NOT NULL, field_value LONGTEXT DEFAULT NULL, INDEX idx_session_field_values_session_id (session_id), INDEX idx_session_field_values_field_id (field_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_lastaccess (access_id BIGINT AUTO_INCREMENT NOT NULL, access_user_id INT DEFAULT NULL, access_date DATETIME NOT NULL, c_id INT NOT NULL, access_tool VARCHAR(30) DEFAULT NULL, access_session_id INT DEFAULT NULL, INDEX access_c_id_user_id (c_id, access_user_id), INDEX access_user_id (access_user_id), INDEX access_cours_code (c_id), INDEX access_session_id (access_session_id), PRIMARY KEY(access_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session (id INT AUTO_INCREMENT NOT NULL, id_coach INT DEFAULT NULL, name VARCHAR(150) NOT NULL, nbr_courses SMALLINT DEFAULT NULL, nbr_users INT DEFAULT NULL, nbr_classes INT DEFAULT NULL, session_admin_id INT DEFAULT NULL, visibility INT NOT NULL, session_category_id INT DEFAULT NULL, promotion_id INT DEFAULT NULL, display_start_date DATETIME NOT NULL, display_end_date DATETIME NOT NULL, access_start_date DATETIME NOT NULL, access_end_date DATETIME NOT NULL, coach_access_start_date DATETIME NOT NULL, coach_access_end_date DATETIME NOT NULL, INDEX IDX_D044D5D4D1DC2CFC (id_coach), INDEX idx_id_session_admin_id (session_admin_id), UNIQUE INDEX name (name), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_audit (id INT NOT NULL, rev INT NOT NULL, id_coach INT DEFAULT NULL, name VARCHAR(150) DEFAULT NULL, nbr_courses SMALLINT DEFAULT NULL, nbr_users INT DEFAULT NULL, nbr_classes INT DEFAULT NULL, session_admin_id INT DEFAULT NULL, visibility INT DEFAULT NULL, session_category_id INT DEFAULT NULL, promotion_id INT DEFAULT NULL, display_start_date DATETIME DEFAULT NULL, display_end_date DATETIME DEFAULT NULL, access_start_date DATETIME DEFAULT NULL, access_end_date DATETIME DEFAULT NULL, coach_access_start_date DATETIME DEFAULT NULL, coach_access_end_date DATETIME DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_certificate (id BIGINT AUTO_INCREMENT NOT NULL, cat_id INT NOT NULL, user_id INT NOT NULL, score_certificate DOUBLE PRECISION NOT NULL, created_at DATETIME NOT NULL, path_certificate LONGTEXT DEFAULT NULL, INDEX idx_gradebook_certificate_category_id (cat_id), INDEX idx_gradebook_certificate_user_id (user_id), INDEX idx_gradebook_certificate_category_id_user_id (cat_id, user_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE sys_announcement (id INT AUTO_INCREMENT NOT NULL, date_start DATETIME NOT NULL, date_end DATETIME NOT NULL, visible_teacher TINYINT(1) NOT NULL, visible_student TINYINT(1) NOT NULL, visible_guest TINYINT(1) NOT NULL, title VARCHAR(250) NOT NULL, content LONGTEXT NOT NULL, lang VARCHAR(70) DEFAULT NULL, access_url_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_downloads (down_id INT AUTO_INCREMENT NOT NULL, down_user_id INT DEFAULT NULL, down_date DATETIME NOT NULL, c_id INT NOT NULL, down_doc_path VARCHAR(255) NOT NULL, down_session_id INT NOT NULL, INDEX down_session_id (down_session_id), PRIMARY KEY(down_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE branch_sync_log (id BIGINT AUTO_INCREMENT NOT NULL, transaction_id BIGINT NOT NULL, import_time DATETIME DEFAULT NULL, message LONGTEXT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_default (default_id INT AUTO_INCREMENT NOT NULL, default_user_id INT NOT NULL, default_cours_code VARCHAR(40) NOT NULL, default_date DATETIME NOT NULL, default_event_type VARCHAR(255) NOT NULL, default_value_type VARCHAR(255) NOT NULL, default_value LONGTEXT NOT NULL, c_id INT DEFAULT NULL, session_id INT DEFAULT NULL, PRIMARY KEY(default_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE curriculum_rel_user (id INT AUTO_INCREMENT NOT NULL, category_id INT NOT NULL, user_id INT NOT NULL, score INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE settings_options (id INT AUTO_INCREMENT NOT NULL, variable VARCHAR(255) DEFAULT NULL, value VARCHAR(255) DEFAULT NULL, display_text VARCHAR(255) NOT NULL, UNIQUE INDEX id (id), UNIQUE INDEX unique_setting_option (variable, value), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_rel_event_type (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, event_type_name VARCHAR(255) NOT NULL, INDEX event_name_index (event_type_name), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE specific_field_values (id INT AUTO_INCREMENT NOT NULL, course_code VARCHAR(40) NOT NULL, tool_id VARCHAR(100) NOT NULL, ref_id INT NOT NULL, field_id INT NOT NULL, value VARCHAR(200) NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE skill_rel_gradebook (id INT AUTO_INCREMENT NOT NULL, gradebook_id INT NOT NULL, skill_id INT NOT NULL, type VARCHAR(10) NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE skill_rel_skill (id INT AUTO_INCREMENT NOT NULL, skill_id INT NOT NULL, parent_id INT NOT NULL, relation_type INT NOT NULL, level INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_type (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(50) NOT NULL, translation_var VARCHAR(40) DEFAULT NULL, description LONGTEXT DEFAULT NULL, props LONGTEXT DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_rel_user (id_session INT NOT NULL, id_user INT NOT NULL, relation_type INT NOT NULL, moved_to INT DEFAULT NULL, moved_status INT DEFAULT NULL, moved_at DATETIME DEFAULT NULL, INDEX idx_session_rel_user_id_user_moved (id_user, moved_to), PRIMARY KEY(id_session, id_user, relation_type)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_rel_user_audit (relation_type INT NOT NULL, rev INT NOT NULL, id_session INT DEFAULT NULL, id_user INT DEFAULT NULL, moved_to INT DEFAULT NULL, moved_status INT DEFAULT NULL, moved_at DATETIME DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(relation_type, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE skill (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, short_code VARCHAR(100) NOT NULL, description LONGTEXT NOT NULL, access_url_id INT NOT NULL, icon VARCHAR(255) NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_field_values (id INT AUTO_INCREMENT NOT NULL, field_id INT NOT NULL, tms DATETIME NOT NULL, user_id VARCHAR(255) NOT NULL, comment VARCHAR(255) DEFAULT NULL, author_id VARCHAR(255) NOT NULL, field_value LONGTEXT DEFAULT NULL, INDEX user_id (user_id, field_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_field_values_audit (id INT NOT NULL, rev INT NOT NULL, field_id INT DEFAULT NULL, author_id VARCHAR(255) DEFAULT NULL, user_id VARCHAR(255) DEFAULT NULL, field_value LONGTEXT DEFAULT NULL, tms DATETIME DEFAULT NULL, comment VARCHAR(255) DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB;");
        $queries->addQuery("CREATE TABLE user_friend_relation_type (id INT AUTO_INCREMENT NOT NULL, title VARCHAR(20) DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_field_options (id INT AUTO_INCREMENT NOT NULL, field_id INT NOT NULL, option_value LONGTEXT DEFAULT NULL, option_display_text VARCHAR(255) DEFAULT NULL, option_order INT DEFAULT NULL, priority INT DEFAULT NULL, priority_message VARCHAR(255) DEFAULT NULL, tms DATETIME NOT NULL, INDEX idx_session_field_options_field_id (field_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE session_path (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_links (links_id INT AUTO_INCREMENT NOT NULL, links_user_id INT DEFAULT NULL, links_date DATETIME NOT NULL, c_id INT NOT NULL, links_link_id INT NOT NULL, links_session_id INT NOT NULL, INDEX links_user_id (links_user_id), INDEX links_session_id (links_session_id), PRIMARY KEY(links_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url_rel_course_category (id INT AUTO_INCREMENT NOT NULL, access_url_id INT NOT NULL, course_category_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_course_category (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, title LONGTEXT NOT NULL, sort INT DEFAULT NULL, INDEX idx_user_c_cat_uid (user_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE ext_log_entries (id INT AUTO_INCREMENT NOT NULL, action VARCHAR(255) DEFAULT NULL, logged_at DATETIME DEFAULT NULL, object_id VARCHAR(64) DEFAULT NULL, object_class VARCHAR(255) DEFAULT NULL, version INT DEFAULT NULL, data VARCHAR(255) DEFAULT NULL, username VARCHAR(255) DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_exercices (exe_id INT AUTO_INCREMENT NOT NULL, exe_user_id INT DEFAULT NULL, exe_date DATETIME NOT NULL, exe_exo_id INT NOT NULL, exe_result DOUBLE PRECISION NOT NULL, exe_weighting DOUBLE PRECISION NOT NULL, c_id INT NOT NULL, status VARCHAR(20) NOT NULL, data_tracking LONGTEXT NOT NULL, start_date DATETIME NOT NULL, steps_counter SMALLINT NOT NULL, session_id INT NOT NULL, orig_lp_id INT NOT NULL, orig_lp_item_id INT NOT NULL, exe_duration INT NOT NULL, expired_time_control DATETIME NOT NULL, orig_lp_item_view_id INT NOT NULL, questions_to_check LONGTEXT NOT NULL, jury_score DOUBLE PRECISION NOT NULL, jury_id INT NOT NULL, INDEX IDX_B62B03F2B9773F9E (exe_exo_id), INDEX IDX_B62B03F2F6A6790 (exe_user_id), PRIMARY KEY(exe_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_stored_values (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, sco_id INT NOT NULL, course_id VARCHAR(40) NOT NULL, sv_key VARCHAR(64) NOT NULL, sv_value LONGTEXT NOT NULL, UNIQUE INDEX user_id_2 (user_id, sco_id, course_id, sv_key), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE tool (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) DEFAULT NULL, image VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE tool_audit (id INT NOT NULL, rev INT NOT NULL, name VARCHAR(255) DEFAULT NULL, image VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB;");

        $queries->addQuery("CREATE TABLE tool_resource_rights (id INT AUTO_INCREMENT NOT NULL, tool_id INT DEFAULT NULL, role VARCHAR(255) NOT NULL, mask INT NOT NULL, INDEX IDX_95CE3398F7B22CC (tool_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB;");
        $queries->addQuery("CREATE TABLE tool_resource_rights_audit (id INT NOT NULL, rev INT NOT NULL, tool_id INT DEFAULT NULL, role VARCHAR(255) DEFAULT NULL, mask INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB;");
        $queries->addQuery("CREATE TABLE resource_rights (id INT AUTO_INCREMENT NOT NULL, resource_link_id INT DEFAULT NULL, role VARCHAR(255) NOT NULL, mask INT NOT NULL, UNIQUE INDEX UNIQ_C99C3BF9F004E599 (resource_link_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB;");
        $queries->addQuery("CREATE TABLE resource_node (id INT AUTO_INCREMENT NOT NULL, tool_id INT DEFAULT NULL, creator_id INT NOT NULL, parent_id INT DEFAULT NULL, name VARCHAR(255) NOT NULL, level INT DEFAULT NULL, path VARCHAR(3000) DEFAULT NULL, created_at DATETIME NOT NULL, updated_at DATETIME NOT NULL, INDEX IDX_8A5F48FF8F7B22CC (tool_id), INDEX IDX_8A5F48FF61220EA6 (creator_id), INDEX IDX_8A5F48FF727ACA70 (parent_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE resource_link (id INT AUTO_INCREMENT NOT NULL, resource_node_id INT DEFAULT NULL, session_id INT DEFAULT NULL, user_id INT DEFAULT NULL, c_id INT DEFAULT NULL, group_id INT DEFAULT NULL, usergroup_id INT DEFAULT NULL, private TINYINT(1) DEFAULT NULL, public TINYINT(1) DEFAULT NULL, INDEX IDX_398C394B1BAD783F (resource_node_id), INDEX IDX_398C394B613FECDF (session_id), INDEX IDX_398C394BA76ED395 (user_id), INDEX IDX_398C394B91D79BD3 (c_id), INDEX IDX_398C394BFE54D947 (group_id), INDEX IDX_398C394BD2112630 (usergroup_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");

        $queries->addQuery("CREATE TABLE track_e_hotspot (hotspot_id INT AUTO_INCREMENT NOT NULL, hotspot_user_id INT NOT NULL, hotspot_exe_id INT NOT NULL, hotspot_question_id INT NOT NULL, hotspot_answer_id INT NOT NULL, hotspot_correct TINYINT(1) NOT NULL, hotspot_coordinate LONGTEXT NOT NULL, c_id INT NOT NULL, INDEX hotspot_user_id (hotspot_user_id), INDEX hotspot_exe_id (hotspot_exe_id), INDEX hotspot_question_id (hotspot_question_id), PRIMARY KEY(hotspot_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE question_field_values (id INT AUTO_INCREMENT NOT NULL, question_id INT NOT NULL, field_id INT NOT NULL, tms DATETIME NOT NULL, user_id VARCHAR(255) NOT NULL, comment VARCHAR(255) DEFAULT NULL, field_value LONGTEXT DEFAULT NULL, INDEX IDX_83093BA61E27F6BF (question_id), INDEX idx_question_field_values_field_id (field_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup (id INT AUTO_INCREMENT NOT NULL, name VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE templates (id INT AUTO_INCREMENT NOT NULL, title VARCHAR(100) NOT NULL, description VARCHAR(250) NOT NULL, course_code VARCHAR(40) NOT NULL, user_id INT NOT NULL, ref_doc INT NOT NULL, image VARCHAR(250) NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE admin (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, UNIQUE INDEX user_id (user_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup_rel_session (id INT AUTO_INCREMENT NOT NULL, usergroup_id INT NOT NULL, session_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_result_log (id INT AUTO_INCREMENT NOT NULL, id_result INT NOT NULL, user_id INT NOT NULL, evaluation_id INT NOT NULL, created_at DATETIME NOT NULL, score DOUBLE PRECISION DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url_rel_usergroup (id INT AUTO_INCREMENT NOT NULL, access_url_id INT NOT NULL, usergroup_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE skill_rel_user (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, skill_id INT NOT NULL, acquired_skill_at DATETIME NOT NULL, assigned_by INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE shared_survey (survey_id INT AUTO_INCREMENT NOT NULL, code VARCHAR(20) DEFAULT NULL, title LONGTEXT DEFAULT NULL, subtitle LONGTEXT DEFAULT NULL, author VARCHAR(250) DEFAULT NULL, lang VARCHAR(20) DEFAULT NULL, template VARCHAR(20) DEFAULT NULL, intro LONGTEXT DEFAULT NULL, surveythanks LONGTEXT DEFAULT NULL, creation_date DATETIME NOT NULL, course_code VARCHAR(40) NOT NULL, UNIQUE INDEX id (survey_id), PRIMARY KEY(survey_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_link (id INT AUTO_INCREMENT NOT NULL, type INT NOT NULL, ref_id INT NOT NULL, user_id INT NOT NULL, course_code VARCHAR(40) NOT NULL, category_id INT NOT NULL, created_at DATETIME NOT NULL, weight DOUBLE PRECISION NOT NULL, visible INT NOT NULL, locked INT NOT NULL, evaluation_type_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_field_values (id INT AUTO_INCREMENT NOT NULL, field_id INT NOT NULL, tms DATETIME NOT NULL, user_id VARCHAR(255) NOT NULL, comment VARCHAR(255) DEFAULT NULL, course_code VARCHAR(255) NOT NULL, field_value LONGTEXT DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_access (access_id INT AUTO_INCREMENT NOT NULL, access_user_id INT DEFAULT NULL, access_date DATETIME NOT NULL, c_id INT NOT NULL, access_tool VARCHAR(30) DEFAULT NULL, access_session_id INT NOT NULL, INDEX access_user_id (access_user_id), INDEX access_cid_user (c_id, access_user_id), INDEX access_session_id (access_session_id), PRIMARY KEY(access_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE sys_calendar (id INT AUTO_INCREMENT NOT NULL, title VARCHAR(255) NOT NULL, content LONGTEXT DEFAULT NULL, start_date DATETIME NOT NULL, end_date DATETIME NOT NULL, access_url_id INT NOT NULL, all_day INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_rel_tag (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, tag_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE legal (legal_id INT NOT NULL, language_id INT NOT NULL, date INT NOT NULL, content LONGTEXT DEFAULT NULL, type INT NOT NULL, changes LONGTEXT NOT NULL, version INT DEFAULT NULL, PRIMARY KEY(legal_id, language_id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE user_session_path (id INT AUTO_INCREMENT NOT NULL, session_path_id INT DEFAULT NULL, user_id INT DEFAULT NULL, status VARCHAR(100) DEFAULT NULL, percentage INT DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url (id INT AUTO_INCREMENT NOT NULL, url VARCHAR(255) NOT NULL, description LONGTEXT DEFAULT NULL, active INT NOT NULL, created_by INT NOT NULL, tms DATETIME NOT NULL, url_type TINYINT(1) DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE access_url_audit (id INT NOT NULL, rev INT NOT NULL, url VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, active INT DEFAULT NULL, created_by INT DEFAULT NULL, tms DATETIME DEFAULT NULL, url_type TINYINT(1) DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup_rel_user (id INT AUTO_INCREMENT NOT NULL, user_id INT DEFAULT NULL, usergroup_id INT DEFAULT NULL, INDEX IDX_739515A9A76ED395 (user_id), INDEX IDX_739515A9D2112630 (usergroup_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup_rel_user_audit (id INT NOT NULL, rev INT NOT NULL, user_id INT DEFAULT NULL, usergroup_id INT DEFAULT NULL, revtype VARCHAR(4) NOT NULL, PRIMARY KEY(id, rev)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE grade_components (id INT AUTO_INCREMENT NOT NULL, percentage VARCHAR(255) NOT NULL, title VARCHAR(255) NOT NULL, acronym VARCHAR(255) NOT NULL, prefix VARCHAR(255) DEFAULT NULL, count_elements INT DEFAULT NULL, exclusions INT DEFAULT NULL, grade_model_id INT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE usergroup_rel_tag (id INT AUTO_INCREMENT NOT NULL, tag_id INT NOT NULL, usergroup_id INT NOT NULL, INDEX usergroup_rel_tag_usergroup_id (usergroup_id), INDEX usergroup_rel_tag_tag_id (tag_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_score_display (id INT AUTO_INCREMENT NOT NULL, score DOUBLE PRECISION NOT NULL, display VARCHAR(40) NOT NULL, category_id INT NOT NULL, score_color_percent DOUBLE PRECISION NOT NULL, INDEX category_id (category_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_item_property (id INT AUTO_INCREMENT NOT NULL, course_id INT NOT NULL, item_property_id INT NOT NULL, title VARCHAR(255) DEFAULT NULL, content LONGTEXT DEFAULT NULL, progress INT NOT NULL, lastedit_date DATETIME NOT NULL, lastedit_user_id INT NOT NULL, session_id INT NOT NULL, INDEX course_id (course_id, item_property_id, session_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_attempt (id INT AUTO_INCREMENT NOT NULL, exe_id INT DEFAULT NULL, user_id INT NOT NULL, question_id INT NOT NULL, answer LONGTEXT NOT NULL, teacher_comment LONGTEXT NOT NULL, marks DOUBLE PRECISION NOT NULL, position INT DEFAULT NULL, tms DATETIME NOT NULL, session_id INT NOT NULL, c_id INT NOT NULL, filename VARCHAR(255) DEFAULT NULL, INDEX exe_id (exe_id), INDEX user_id (user_id), INDEX question_id (question_id), INDEX session_id (session_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_attempt_recording (id INT AUTO_INCREMENT NOT NULL, exe_id INT NOT NULL, question_id INT NOT NULL, marks INT NOT NULL, insert_date DATETIME NOT NULL, author INT NOT NULL, teacher_comment LONGTEXT NOT NULL, session_id INT NOT NULL, INDEX exe_id (exe_id), INDEX question_id (question_id), INDEX session_id (session_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE curriculum_category (id INT AUTO_INCREMENT NOT NULL, parent_id INT DEFAULT NULL, c_id INT DEFAULT NULL, session_id INT DEFAULT NULL, title VARCHAR(255) DEFAULT NULL, max_score INT NOT NULL, min_chars TINYINT(1) NOT NULL, lvl INT NOT NULL, lft INT NOT NULL, rgt INT NOT NULL, root INT DEFAULT NULL, INDEX IDX_FC94C785727ACA70 (parent_id), INDEX IDX_FC94C78591D79BD3 (c_id), INDEX IDX_FC94C785613FECDF (session_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE chat (id INT AUTO_INCREMENT NOT NULL, from_user INT DEFAULT NULL, to_user INT DEFAULT NULL, message LONGTEXT NOT NULL, sent DATETIME NOT NULL, recd INT NOT NULL, INDEX idx_chat_to_user (to_user), INDEX idx_chat_from_user (from_user), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE course_field (id INT AUTO_INCREMENT NOT NULL, field_type INT NOT NULL, field_variable VARCHAR(64) NOT NULL, field_display_text VARCHAR(64) DEFAULT NULL, field_default_value LONGTEXT DEFAULT NULL, field_order INT DEFAULT NULL, field_visible TINYINT(1) DEFAULT NULL, field_changeable TINYINT(1) DEFAULT NULL, field_filter TINYINT(1) DEFAULT NULL, field_loggeable INT DEFAULT NULL, tms DATETIME NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE gradebook_category (id INT AUTO_INCREMENT NOT NULL, name LONGTEXT NOT NULL, description LONGTEXT DEFAULT NULL, user_id INT NOT NULL, course_code VARCHAR(40) DEFAULT NULL, parent_id INT DEFAULT NULL, weight DOUBLE PRECISION NOT NULL, visible TINYINT(1) NOT NULL, certif_min_score INT DEFAULT NULL, session_id INT DEFAULT NULL, document_id INT DEFAULT NULL, locked INT NOT NULL, default_lowest_eval_exclude TINYINT(1) DEFAULT NULL, grade_model_id INT DEFAULT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE curriculum_item_rel_user (id INT AUTO_INCREMENT NOT NULL, user_id INT NOT NULL, item_id INT NOT NULL, order_id TINYINT(1) NOT NULL, description VARCHAR(255) NOT NULL, INDEX IDX_514721FFA76ED395 (user_id), INDEX IDX_514721FF126F525E (item_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE track_e_hotpotatoes (id INT AUTO_INCREMENT NOT NULL, exe_name VARCHAR(255) NOT NULL, exe_user_id INT DEFAULT NULL, exe_date DATETIME NOT NULL, c_id INT NOT NULL, exe_result SMALLINT NOT NULL, exe_weighting SMALLINT NOT NULL, PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE branch_sync (id INT AUTO_INCREMENT NOT NULL, parent_id INT DEFAULT NULL, access_url_id INT NOT NULL, branch_name VARCHAR(250) DEFAULT NULL, branch_ip VARCHAR(40) DEFAULT NULL, latitude NUMERIC(10, 0) DEFAULT NULL, longitude NUMERIC(10, 0) DEFAULT NULL, dwn_speed INT DEFAULT NULL, up_speed INT DEFAULT NULL, delay INT DEFAULT NULL, admin_mail VARCHAR(250) DEFAULT NULL, admin_name VARCHAR(250) DEFAULT NULL, admin_phone VARCHAR(250) DEFAULT NULL, last_sync_trans_id BIGINT DEFAULT NULL, last_sync_trans_date DATETIME DEFAULT NULL, last_sync_type VARCHAR(20) DEFAULT NULL, ssl_pub_key VARCHAR(250) DEFAULT NULL, branch_type VARCHAR(250) DEFAULT NULL, lft INT DEFAULT NULL, rgt INT DEFAULT NULL, lvl INT DEFAULT NULL, root INT DEFAULT NULL, INDEX IDX_F62F45ED727ACA70 (parent_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");

        $queries->addQuery("CREATE TABLE question_field_options (id INT AUTO_INCREMENT NOT NULL, field_id INT NOT NULL, option_value LONGTEXT DEFAULT NULL, option_display_text VARCHAR(255) DEFAULT NULL, option_order INT DEFAULT NULL, priority INT DEFAULT NULL, priority_message VARCHAR(255) DEFAULT NULL, tms DATETIME NOT NULL, INDEX idx_question_field_options_field_id (field_id), PRIMARY KEY(id)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB;");

        $queries->addQuery("ALTER TABLE user_accessurl ADD CONSTRAINT FK_DD3D6AB5A76ED395 FOREIGN KEY (user_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE user_accessurl ADD CONSTRAINT FK_DD3D6AB573444FD5 FOREIGN KEY (access_url_id) REFERENCES access_url (id)");
        $queries->addQuery("ALTER TABLE jury_members ADD CONSTRAINT FK_CCB37077E560103C FOREIGN KEY (jury_id) REFERENCES jury (id)");
        $queries->addQuery("ALTER TABLE course_rel_user ADD CONSTRAINT FK_92CFD9FEA76ED395 FOREIGN KEY (user_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE course_rel_user ADD CONSTRAINT FK_92CFD9FE91D79BD3 FOREIGN KEY (c_id) REFERENCES course (id)");
        $queries->addQuery("ALTER TABLE session_rel_course ADD CONSTRAINT FK_12D110D3ED97CA4 FOREIGN KEY (id_session) REFERENCES session (id)");
        $queries->addQuery("ALTER TABLE session_rel_course ADD CONSTRAINT FK_12D110D391D79BD3 FOREIGN KEY (c_id) REFERENCES course (id)");
        $queries->addQuery("ALTER TABLE curriculum_item ADD CONSTRAINT FK_5A9A424112469DE2 FOREIGN KEY (category_id) REFERENCES curriculum_category (id)");
        $queries->addQuery("ALTER TABLE session_tree ADD CONSTRAINT FK_714F5EF6727ACA70 FOREIGN KEY (parent_id) REFERENCES session_tree (id) ON DELETE SET NULL");
        $queries->addQuery("ALTER TABLE session_tree ADD CONSTRAINT FK_714F5EF68F7B22CC FOREIGN KEY (tool_id) REFERENCES tool (id)");
        $queries->addQuery("ALTER TABLE session_tree ADD CONSTRAINT FK_714F5EF6CBB4D431 FOREIGN KEY (session_path_id) REFERENCES session_path (id)");
        $queries->addQuery("ALTER TABLE session_tree ADD CONSTRAINT FK_714F5EF6591CC992 FOREIGN KEY (course_id) REFERENCES course (id)");
        $queries->addQuery("ALTER TABLE session_tree ADD CONSTRAINT FK_714F5EF6613FECDF FOREIGN KEY (session_id) REFERENCES session (id)");
        $queries->addQuery("ALTER TABLE question_score_name ADD CONSTRAINT FK_13EF60F871E3BA5D FOREIGN KEY (question_score_id) REFERENCES question_score (id)");
        $queries->addQuery("ALTER TABLE access_url_rel_course ADD CONSTRAINT FK_8E97FC0891D79BD3 FOREIGN KEY (c_id) REFERENCES course (id)");
        $queries->addQuery("ALTER TABLE access_url_rel_course ADD CONSTRAINT FK_8E97FC0873444FD5 FOREIGN KEY (access_url_id) REFERENCES access_url (id)");
        $queries->addQuery("ALTER TABLE jury ADD CONSTRAINT FK_1335B02CDCD6CC49 FOREIGN KEY (branch_id) REFERENCES branch_sync (id)");
        $queries->addQuery("ALTER TABLE track_attempt_jury ADD CONSTRAINT FK_977B4A18B5A18F57 FOREIGN KEY (exe_id) REFERENCES track_e_exercices (exe_id)");
        $queries->addQuery("ALTER TABLE session ADD CONSTRAINT FK_D044D5D4D1DC2CFC FOREIGN KEY (id_coach) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE track_e_exercices ADD CONSTRAINT FK_B62B03F2F6A6790 FOREIGN KEY (exe_user_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE usergroup_rel_user ADD CONSTRAINT FK_739515A9A76ED395 FOREIGN KEY (user_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE usergroup_rel_user ADD CONSTRAINT FK_739515A9D2112630 FOREIGN KEY (usergroup_id) REFERENCES usergroup (id)");
        $queries->addQuery("ALTER TABLE curriculum_category ADD CONSTRAINT FK_FC94C785727ACA70 FOREIGN KEY (parent_id) REFERENCES curriculum_category (id) ON DELETE SET NULL");
        $queries->addQuery("ALTER TABLE curriculum_category ADD CONSTRAINT FK_FC94C78591D79BD3 FOREIGN KEY (c_id) REFERENCES course (id)");
        $queries->addQuery("ALTER TABLE curriculum_category ADD CONSTRAINT FK_FC94C785613FECDF FOREIGN KEY (session_id) REFERENCES session (id)");
        $queries->addQuery("ALTER TABLE curriculum_item_rel_user ADD CONSTRAINT FK_514721FFA76ED395 FOREIGN KEY (user_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE curriculum_item_rel_user ADD CONSTRAINT FK_514721FF126F525E FOREIGN KEY (item_id) REFERENCES curriculum_item (id)");
        $queries->addQuery("ALTER TABLE branch_sync ADD CONSTRAINT FK_F62F45ED727ACA70 FOREIGN KEY (parent_id) REFERENCES branch_sync (id) ON DELETE SET NULL");
        $queries->addQuery("ALTER TABLE settings_current ADD namespace VARCHAR(255) NOT NULL");
        $queries->addQuery("ALTER TABLE settings_current ADD name VARCHAR(255) NOT NULL");
    }

    public function down(Schema $schema)
    {
        $queries->addQuery("ALTER TABLE user_accessurl DROP FOREIGN KEY FK_DD3D6AB5A76ED395");
        $queries->addQuery("ALTER TABLE fos_user_user_group DROP FOREIGN KEY FK_B3C77447A76ED395");
        $queries->addQuery("ALTER TABLE course_rel_user DROP FOREIGN KEY FK_92CFD9FEA76ED395");
        $queries->addQuery("ALTER TABLE session DROP FOREIGN KEY FK_D044D5D4D1DC2CFC");
        $queries->addQuery("ALTER TABLE track_e_exercices DROP FOREIGN KEY FK_B62B03F2F6A6790");
        $queries->addQuery("ALTER TABLE usergroup_rel_user DROP FOREIGN KEY FK_739515A9A76ED395");
        $queries->addQuery("ALTER TABLE curriculum_item_rel_user DROP FOREIGN KEY FK_514721FFA76ED395");
        $queries->addQuery("ALTER TABLE curriculum_item_rel_user DROP FOREIGN KEY FK_514721FF126F525E");
        $queries->addQuery("ALTER TABLE course_rel_user DROP FOREIGN KEY FK_92CFD9FE91D79BD3");
        $queries->addQuery("ALTER TABLE session_rel_course DROP FOREIGN KEY FK_12D110D391D79BD3");
        $queries->addQuery("ALTER TABLE session_tree DROP FOREIGN KEY FK_714F5EF6591CC992");
        $queries->addQuery("ALTER TABLE access_url_rel_course DROP FOREIGN KEY FK_8E97FC0891D79BD3");
        $queries->addQuery("ALTER TABLE curriculum_category DROP FOREIGN KEY FK_FC94C78591D79BD3");
        $queries->addQuery("ALTER TABLE session_tree DROP FOREIGN KEY FK_714F5EF6727ACA70");
        $queries->addQuery("ALTER TABLE question_score_name DROP FOREIGN KEY FK_13EF60F871E3BA5D");
        $queries->addQuery("ALTER TABLE jury_members DROP FOREIGN KEY FK_CCB37077E560103C");
        $queries->addQuery("ALTER TABLE session_rel_course DROP FOREIGN KEY FK_12D110D3ED97CA4");
        $queries->addQuery("ALTER TABLE session_tree DROP FOREIGN KEY FK_714F5EF6613FECDF");
        $queries->addQuery("ALTER TABLE curriculum_category DROP FOREIGN KEY FK_FC94C785613FECDF");
        $queries->addQuery("ALTER TABLE session_tree DROP FOREIGN KEY FK_714F5EF6CBB4D431");
        $queries->addQuery("ALTER TABLE track_attempt_jury DROP FOREIGN KEY FK_977B4A18B5A18F57");
        $queries->addQuery("ALTER TABLE session_tree DROP FOREIGN KEY FK_714F5EF68F7B22CC");
        $queries->addQuery("ALTER TABLE usergroup_rel_user DROP FOREIGN KEY FK_739515A9D2112630");
        $queries->addQuery("ALTER TABLE user_accessurl DROP FOREIGN KEY FK_DD3D6AB573444FD5");
        $queries->addQuery("ALTER TABLE access_url_rel_course DROP FOREIGN KEY FK_8E97FC0873444FD5");
        $queries->addQuery("ALTER TABLE curriculum_item DROP FOREIGN KEY FK_5A9A424112469DE2");
        $queries->addQuery("ALTER TABLE curriculum_category DROP FOREIGN KEY FK_FC94C785727ACA70");
        $queries->addQuery("ALTER TABLE jury DROP FOREIGN KEY FK_1335B02CDCD6CC49");
        $queries->addQuery("ALTER TABLE branch_sync DROP FOREIGN KEY FK_F62F45ED727ACA70");

        $queries->addQuery("DROP TABLE user");
        $queries->addQuery("DROP TABLE user_accessurl");
        $queries->addQuery("DROP TABLE fos_user_user_group");
        $queries->addQuery("DROP TABLE user_audit");
        $queries->addQuery("DROP TABLE jury_members");
        $queries->addQuery("DROP TABLE branch_transaction_data");
        $queries->addQuery("DROP TABLE track_e_online");
        $queries->addQuery("DROP TABLE search_engine_ref");
        $queries->addQuery("DROP TABLE promotion");
        $queries->addQuery("DROP TABLE course_module");
        $queries->addQuery("DROP TABLE groups");
        $queries->addQuery("DROP TABLE course_rel_user");
        $queries->addQuery("DROP TABLE course_rel_user_audit");
        $queries->addQuery("DROP TABLE session_rel_course");
        $queries->addQuery("DROP TABLE session_rel_course_audit");
        $queries->addQuery("DROP TABLE access_url_rel_session");
        $queries->addQuery("DROP TABLE curriculum_item");
        $queries->addQuery("DROP TABLE question_field");
        $queries->addQuery("DROP TABLE gradebook_result");
        $queries->addQuery("DROP TABLE personal_agenda");
        $queries->addQuery("DROP TABLE session_field");
        $queries->addQuery("DROP TABLE course_request");
        $queries->addQuery("DROP TABLE shared_survey_question_option");
        $queries->addQuery("DROP TABLE settings_current");
        $queries->addQuery("DROP TABLE gradebook_evaluation_type");
        $queries->addQuery("DROP TABLE grade_model");
        $queries->addQuery("DROP TABLE usergroup_rel_course");
        $queries->addQuery("DROP TABLE user_field_options");
        $queries->addQuery("DROP TABLE skill_profile");
        $queries->addQuery("DROP TABLE personal_agenda_repeat");
        $queries->addQuery("DROP TABLE gradebook_evaluation");
        $queries->addQuery("DROP TABLE course");
        $queries->addQuery("DROP TABLE course_audit");
        $queries->addQuery("DROP TABLE session_tree");
        $queries->addQuery("DROP TABLE question_score_name");
        $queries->addQuery("DROP TABLE access_url_rel_user");
        $queries->addQuery("DROP TABLE skill_rel_profile");
        $queries->addQuery("DROP TABLE notification");
        $queries->addQuery("DROP TABLE block");
        $queries->addQuery("DROP TABLE track_course_ranking");
        $queries->addQuery("DROP TABLE event_sent");
        $queries->addQuery("DROP TABLE branch_transaction_status");
        $queries->addQuery("DROP TABLE track_e_attempt_coeff");
        $queries->addQuery("DROP TABLE usergroup_rel_question");
        $queries->addQuery("DROP TABLE extra_field_option_rel_field_option");
        $queries->addQuery("DROP TABLE shared_survey_question");
        $queries->addQuery("DROP TABLE session_category");
        $queries->addQuery("DROP TABLE course_category");
        $queries->addQuery("DROP TABLE gradebook_linkeval_log");
        $queries->addQuery("DROP TABLE tag");
        $queries->addQuery("DROP TABLE track_e_login");
        $queries->addQuery("DROP TABLE Comment");
        $queries->addQuery("DROP TABLE course_field_options");
        $queries->addQuery("DROP TABLE access_url_rel_course");
        $queries->addQuery("DROP TABLE access_url_rel_course_audit");
        $queries->addQuery("DROP TABLE usergroup_rel_usergroup");
        $queries->addQuery("DROP TABLE personal_agenda_repeat_not");
        $queries->addQuery("DROP TABLE user_api_key");
        $queries->addQuery("DROP TABLE career");
        $queries->addQuery("DROP TABLE announcement_rel_group");
        $queries->addQuery("DROP TABLE track_e_course_access");
        $queries->addQuery("DROP TABLE question_score");
        $queries->addQuery("DROP TABLE user_rel_course_vote");
        $queries->addQuery("DROP TABLE specific_field");
        $queries->addQuery("DROP TABLE track_e_uploads");
        $queries->addQuery("DROP TABLE branch_transaction");
        $queries->addQuery("DROP TABLE session_rel_course_rel_user");
        $queries->addQuery("DROP TABLE system_template");
        $queries->addQuery("DROP TABLE jury");
        $queries->addQuery("DROP TABLE user_rel_user");
        $queries->addQuery("DROP TABLE event_email_template");
        $queries->addQuery("DROP TABLE language");
        $queries->addQuery("DROP TABLE user_field");
        $queries->addQuery("DROP TABLE track_stored_values_stack");
        $queries->addQuery("DROP TABLE track_attempt_jury");
        $queries->addQuery("DROP TABLE session_field_values");
        $queries->addQuery("DROP TABLE track_e_lastaccess");
        $queries->addQuery("DROP TABLE session");
        $queries->addQuery("DROP TABLE session_audit");
        $queries->addQuery("DROP TABLE gradebook_certificate");
        $queries->addQuery("DROP TABLE sys_announcement");
        $queries->addQuery("DROP TABLE track_e_downloads");
        $queries->addQuery("DROP TABLE branch_sync_log");
        $queries->addQuery("DROP TABLE track_e_default");
        $queries->addQuery("DROP TABLE curriculum_rel_user");
        $queries->addQuery("DROP TABLE settings_options");
        $queries->addQuery("DROP TABLE user_rel_event_type");
        $queries->addQuery("DROP TABLE specific_field_values");
        $queries->addQuery("DROP TABLE skill_rel_gradebook");
        $queries->addQuery("DROP TABLE skill_rel_skill");
        $queries->addQuery("DROP TABLE course_type");
        $queries->addQuery("DROP TABLE session_rel_user");
        $queries->addQuery("DROP TABLE skill");
        $queries->addQuery("DROP TABLE user_field_values");
        $queries->addQuery("DROP TABLE user_friend_relation_type");
        $queries->addQuery("DROP TABLE session_field_options");
        $queries->addQuery("DROP TABLE session_path");
        $queries->addQuery("DROP TABLE track_e_links");
        $queries->addQuery("DROP TABLE access_url_rel_course_category");
        $queries->addQuery("DROP TABLE user_course_category");
        $queries->addQuery("DROP TABLE ext_log_entries");
        $queries->addQuery("DROP TABLE track_e_exercices");
        $queries->addQuery("DROP TABLE track_stored_values");
        $queries->addQuery("DROP TABLE tool");
        $queries->addQuery("DROP TABLE track_e_hotspot");
        $queries->addQuery("DROP TABLE question_field_values");
        $queries->addQuery("DROP TABLE usergroup");
        $queries->addQuery("DROP TABLE templates");
        $queries->addQuery("DROP TABLE admin");
        $queries->addQuery("DROP TABLE usergroup_rel_session");
        $queries->addQuery("DROP TABLE gradebook_result_log");
        $queries->addQuery("DROP TABLE access_url_rel_usergroup");
        $queries->addQuery("DROP TABLE skill_rel_user");
        $queries->addQuery("DROP TABLE shared_survey");
        $queries->addQuery("DROP TABLE gradebook_link");
        $queries->addQuery("DROP TABLE course_field_values");
        $queries->addQuery("DROP TABLE track_e_access");
        $queries->addQuery("DROP TABLE sys_calendar");
        $queries->addQuery("DROP TABLE user_rel_tag");
        $queries->addQuery("DROP TABLE legal");
        $queries->addQuery("DROP TABLE user_session_path");
        $queries->addQuery("DROP TABLE access_url");
        $queries->addQuery("DROP TABLE access_url_audit");
        $queries->addQuery("DROP TABLE usergroup_rel_user");
        $queries->addQuery("DROP TABLE grade_components");
        $queries->addQuery("DROP TABLE usergroup_rel_tag");
        $queries->addQuery("DROP TABLE gradebook_score_display");
        $queries->addQuery("DROP TABLE track_e_item_property");
        $queries->addQuery("DROP TABLE track_e_attempt");
        $queries->addQuery("DROP TABLE track_e_attempt_recording");
        $queries->addQuery("DROP TABLE curriculum_category");
        $queries->addQuery("DROP TABLE chat");
        $queries->addQuery("DROP TABLE course_field");
        $queries->addQuery("DROP TABLE gradebook_category");
        $queries->addQuery("DROP TABLE curriculum_item_rel_user");
        $queries->addQuery("DROP TABLE track_e_hotpotatoes");
        $queries->addQuery("DROP TABLE branch_sync");
        $queries->addQuery("DROP TABLE c_quiz_question");
        $queries->addQuery("DROP TABLE resource_node");
        $queries->addQuery("DROP TABLE resource_link");
        //$queries->addQuery("DROP TABLE resource_node_audit");
        //$queries->addQuery("DROP TABLE resource_link_audit");
        $queries->addQuery("ALTER TABLE settings_current DROP namespace");
        $queries->addQuery("ALTER TABLE settings_current DROP name");
    }
}
