<?php

namespace Chamilo\CourseBundle\Migrations\Schema\v2;

use Doctrine\DBAL\Schema\Schema;
use Oro\Bundle\MigrationBundle\Migration\Migration;
use Oro\Bundle\MigrationBundle\Migration\QueryBag;

class CourseBundle implements Migration
{
    public function up(Schema $schema, QueryBag $queries)
    {
        $queries->addPostQuery("CREATE TABLE c_quiz_question (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, question LONGTEXT NOT NULL, description LONGTEXT DEFAULT NULL, ponderation DOUBLE PRECISION NOT NULL, position INT NOT NULL, type TINYINT(1) NOT NULL, picture VARCHAR(50) DEFAULT NULL, level INT NOT NULL, extra VARCHAR(255) DEFAULT NULL, question_code VARCHAR(10) DEFAULT NULL, parent_id INT NOT NULL, INDEX idx_c_q_qst_cpt (c_id, parent_id, type), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_group_info (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, name VARCHAR(100) DEFAULT NULL, category_id INT NOT NULL, description LONGTEXT DEFAULT NULL, max_student INT NOT NULL, doc_state TINYINT(1) NOT NULL, calendar_state TINYINT(1) NOT NULL, work_state TINYINT(1) NOT NULL, announcements_state TINYINT(1) NOT NULL, forum_state TINYINT(1) NOT NULL, wiki_state TINYINT(1) NOT NULL, chat_state TINYINT(1) NOT NULL, secret_directory VARCHAR(255) DEFAULT NULL, self_registration_allowed TINYINT(1) NOT NULL, self_unregistration_allowed TINYINT(1) NOT NULL, session_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_notification (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, forum_id INT NOT NULL, thread_id INT NOT NULL, post_id INT NOT NULL, INDEX user_id (user_id), INDEX forum_id (forum_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_wiki (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, page_id INT NOT NULL, reflink VARCHAR(255) NOT NULL, title VARCHAR(255) NOT NULL, content LONGTEXT NOT NULL, user_id INT NOT NULL, group_id INT DEFAULT NULL, dtime DATETIME NOT NULL, addlock INT NOT NULL, editlock INT NOT NULL, visibility INT NOT NULL, addlock_disc INT NOT NULL, visibility_disc INT NOT NULL, ratinglock_disc INT NOT NULL, assignment INT NOT NULL, comment LONGTEXT NOT NULL, progress LONGTEXT NOT NULL, score INT DEFAULT NULL, version INT DEFAULT NULL, is_editing INT NOT NULL, time_edit DATETIME NOT NULL, hits INT DEFAULT NULL, linksto LONGTEXT NOT NULL, tag LONGTEXT NOT NULL, user_ip VARCHAR(39) NOT NULL, session_id INT DEFAULT NULL, INDEX reflink (reflink), INDEX group_id (group_id), INDEX page_id (page_id), INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_course_setting (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, variable VARCHAR(255) NOT NULL, subkey VARCHAR(255) DEFAULT NULL, type VARCHAR(255) DEFAULT NULL, category VARCHAR(255) DEFAULT NULL, value VARCHAR(255) NOT NULL, title VARCHAR(255) NOT NULL, comment VARCHAR(255) DEFAULT NULL, subkeytext VARCHAR(255) DEFAULT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_permission_task (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, task_id INT NOT NULL, tool VARCHAR(250) NOT NULL, action VARCHAR(250) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_dropbox_category (iid INT AUTO_INCREMENT NOT NULL, cat_id INT NOT NULL, c_id INT NOT NULL, cat_name LONGTEXT NOT NULL, received TINYINT(1) NOT NULL, sent TINYINT(1) NOT NULL, user_id INT NOT NULL, session_id INT NOT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_wiki_discuss (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, publication_id INT NOT NULL, userc_id INT NOT NULL, comment LONGTEXT NOT NULL, p_score VARCHAR(255) DEFAULT NULL, dtime DATETIME NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_dropbox_file (iid INT AUTO_INCREMENT NOT NULL, uploader_id INT NOT NULL, id INT NOT NULL, c_id INT NOT NULL, filename VARCHAR(250) NOT NULL, filesize INT NOT NULL, title VARCHAR(250) DEFAULT NULL, description VARCHAR(250) DEFAULT NULL, author VARCHAR(250) DEFAULT NULL, upload_date DATETIME NOT NULL, last_upload_date DATETIME NOT NULL, cat_id INT NOT NULL, session_id INT NOT NULL, INDEX IDX_4D71B46C16678C77 (uploader_id), INDEX session_id (session_id), UNIQUE INDEX UN_filename (filename), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz_rel_question (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, question_id INT NOT NULL, exercice_id INT NOT NULL, question_order INT NOT NULL, INDEX idx_cqrq_id (question_id), INDEX idx_cqrq_cidexid (c_id, exercice_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_calendar_event (iid INT AUTO_INCREMENT NOT NULL, id INT NOT NULL, c_id INT NOT NULL, title VARCHAR(255) NOT NULL, content LONGTEXT DEFAULT NULL, start_date DATETIME NOT NULL, end_date DATETIME NOT NULL, parent_event_id INT DEFAULT NULL, session_id INT NOT NULL, all_day INT NOT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog_rating (iid INT AUTO_INCREMENT NOT NULL, rating_id INT NOT NULL, c_id INT NOT NULL, blog_id INT NOT NULL, rating_type VARCHAR(100) NOT NULL, item_id INT NOT NULL, user_id INT NOT NULL, rating INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz_category (iid BIGINT AUTO_INCREMENT NOT NULL, parent_id BIGINT DEFAULT NULL, c_id INT NOT NULL, title VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, lft INT NOT NULL, lvl INT NOT NULL, rgt INT NOT NULL, root INT DEFAULT NULL, visibility INT NOT NULL, INDEX IDX_2AF3F510727ACA70 (parent_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_thematic (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, title VARCHAR(255) NOT NULL, content LONGTEXT DEFAULT NULL, display_order INT NOT NULL, active TINYINT(1) NOT NULL, session_id INT NOT NULL, INDEX active (active, session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_survey (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, survey_id INT NOT NULL, code VARCHAR(20) DEFAULT NULL, title LONGTEXT DEFAULT NULL, subtitle LONGTEXT DEFAULT NULL, author VARCHAR(20) DEFAULT NULL, lang VARCHAR(20) DEFAULT NULL, avail_from DATE DEFAULT NULL, avail_till DATE DEFAULT NULL, is_shared VARCHAR(1) DEFAULT NULL, template VARCHAR(20) DEFAULT NULL, intro LONGTEXT DEFAULT NULL, surveythanks LONGTEXT DEFAULT NULL, creation_date DATETIME NOT NULL, invited INT NOT NULL, answered INT NOT NULL, invite_mail LONGTEXT NOT NULL, reminder_mail LONGTEXT NOT NULL, mail_subject VARCHAR(255) NOT NULL, anonymous VARCHAR(255) NOT NULL, access_condition LONGTEXT DEFAULT NULL, shuffle TINYINT(1) NOT NULL, one_question_per_page TINYINT(1) NOT NULL, survey_version VARCHAR(255) NOT NULL, parent_id INT NOT NULL, survey_type INT NOT NULL, show_form_profile INT NOT NULL, form_fields LONGTEXT NOT NULL, session_id INT NOT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_announcement_attachment (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, path VARCHAR(255) NOT NULL, comment LONGTEXT DEFAULT NULL, size INT NOT NULL, announcement_id INT NOT NULL, filename VARCHAR(255) NOT NULL, UNIQUE INDEX c_id (c_id, id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_lp (iid INT AUTO_INCREMENT NOT NULL, id INT NOT NULL, c_id INT NOT NULL, lp_type INT NOT NULL, name VARCHAR(255) NOT NULL, ref LONGTEXT DEFAULT NULL, description LONGTEXT DEFAULT NULL, path LONGTEXT NOT NULL, force_commit TINYINT(1) NOT NULL, default_view_mod VARCHAR(32) NOT NULL, default_encoding VARCHAR(32) NOT NULL, display_order INT NOT NULL, content_maker LONGTEXT NOT NULL, content_local VARCHAR(32) NOT NULL, content_license LONGTEXT NOT NULL, prevent_reinit TINYINT(1) NOT NULL, js_lib LONGTEXT NOT NULL, debug TINYINT(1) NOT NULL, theme VARCHAR(255) NOT NULL, preview_image VARCHAR(255) NOT NULL, author VARCHAR(255) NOT NULL, session_id INT NOT NULL, prerequisite INT NOT NULL, hide_toc_frame TINYINT(1) NOT NULL, seriousgame_mode TINYINT(1) NOT NULL, use_max_score INT NOT NULL, autolunch INT NOT NULL, created_on DATETIME NOT NULL, modified_on DATETIME NOT NULL, publicated_on DATETIME NOT NULL, expired_on DATETIME NOT NULL, category_id INT NOT NULL, max_attempts INT NOT NULL, subscribe_users INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz_order (iid BIGINT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, session_id INT NOT NULL, exercise_id INT NOT NULL, exercise_order INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_lp_iv_objective (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id BIGINT NOT NULL, lp_iv_id BIGINT NOT NULL, order_id INT NOT NULL, objective_id VARCHAR(255) NOT NULL, score_raw DOUBLE PRECISION NOT NULL, score_max DOUBLE PRECISION NOT NULL, score_min DOUBLE PRECISION NOT NULL, status VARCHAR(32) NOT NULL, INDEX lp_iv_id (lp_iv_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_dropbox_person (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, file_id INT NOT NULL, user_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_announcement (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, title LONGTEXT DEFAULT NULL, content LONGTEXT DEFAULT NULL, end_date DATE DEFAULT NULL, display_order INT NOT NULL, email_sent TINYINT(1) DEFAULT NULL, session_id INT DEFAULT NULL, INDEX session_id (session_id), UNIQUE INDEX iid (iid), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_survey_answer (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, answer_id INT NOT NULL, survey_id INT NOT NULL, question_id INT NOT NULL, option_id LONGTEXT NOT NULL, value INT NOT NULL, user VARCHAR(250) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_thread_qualify (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, thread_id INT NOT NULL, qualify DOUBLE PRECISION NOT NULL, qualify_user_id INT DEFAULT NULL, qualify_time DATETIME DEFAULT NULL, session_id INT DEFAULT NULL, INDEX user_id (user_id, thread_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog_post (iid INT AUTO_INCREMENT NOT NULL, post_id INT NOT NULL, c_id INT NOT NULL, title VARCHAR(250) NOT NULL, full_text LONGTEXT NOT NULL, date_creation DATETIME NOT NULL, blog_id INT NOT NULL, author_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_group_category (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, title VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, doc_state TINYINT(1) NOT NULL, calendar_state TINYINT(1) NOT NULL, work_state TINYINT(1) NOT NULL, announcements_state TINYINT(1) NOT NULL, forum_state TINYINT(1) NOT NULL, wiki_state TINYINT(1) NOT NULL, chat_state TINYINT(1) NOT NULL, max_student INT NOT NULL, self_reg_allowed TINYINT(1) NOT NULL, self_unreg_allowed TINYINT(1) NOT NULL, groups_per_user INT NOT NULL, display_order INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_forum (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, forum_id INT NOT NULL, forum_title VARCHAR(255) NOT NULL, forum_comment LONGTEXT DEFAULT NULL, forum_threads INT DEFAULT NULL, forum_posts INT DEFAULT NULL, forum_last_post INT DEFAULT NULL, forum_category INT DEFAULT NULL, allow_anonymous INT DEFAULT NULL, allow_edit INT DEFAULT NULL, approval_direct_post VARCHAR(20) DEFAULT NULL, allow_attachments INT DEFAULT NULL, allow_new_threads INT DEFAULT NULL, default_view VARCHAR(20) DEFAULT NULL, forum_of_group VARCHAR(20) DEFAULT NULL, forum_group_public_private VARCHAR(20) DEFAULT NULL, forum_order INT DEFAULT NULL, locked INT NOT NULL, session_id INT NOT NULL, forum_image VARCHAR(255) NOT NULL, start_time DATETIME NOT NULL, end_time DATETIME NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_lp_item (iid INT AUTO_INCREMENT NOT NULL, id INT NOT NULL, c_id INT NOT NULL, lp_id INT NOT NULL, item_type VARCHAR(32) NOT NULL, ref LONGTEXT NOT NULL, title VARCHAR(511) NOT NULL, description VARCHAR(511) NOT NULL, path LONGTEXT NOT NULL, min_score DOUBLE PRECISION NOT NULL, max_score DOUBLE PRECISION DEFAULT NULL, mastery_score DOUBLE PRECISION DEFAULT NULL, parent_item_id INT NOT NULL, previous_item_id INT NOT NULL, next_item_id INT NOT NULL, display_order INT NOT NULL, prerequisite LONGTEXT DEFAULT NULL, parameters LONGTEXT DEFAULT NULL, launch_data LONGTEXT NOT NULL, max_time_allowed VARCHAR(13) DEFAULT NULL, terms LONGTEXT DEFAULT NULL, search_did INT DEFAULT NULL, audio VARCHAR(250) DEFAULT NULL, INDEX lp_id (lp_id), INDEX idx_c_lp_item_cid_lp_id (c_id, lp_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_group_rel_user (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, group_id INT NOT NULL, status INT NOT NULL, role VARCHAR(50) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_lp_view (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, lp_id INT NOT NULL, user_id INT NOT NULL, view_count INT NOT NULL, last_item INT NOT NULL, progress INT DEFAULT NULL, session_id INT NOT NULL, INDEX lp_id (lp_id), INDEX user_id (user_id), INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_link_category (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, category_title VARCHAR(255) NOT NULL, description LONGTEXT DEFAULT NULL, display_order INT NOT NULL, session_id INT DEFAULT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, title VARCHAR(255) NOT NULL, description LONGTEXT DEFAULT NULL, sound VARCHAR(255) DEFAULT NULL, type TINYINT(1) NOT NULL, random INT NOT NULL, random_answers TINYINT(1) NOT NULL, active TINYINT(1) NOT NULL, results_disabled INT NOT NULL, access_condition LONGTEXT DEFAULT NULL, max_attempt INT NOT NULL, start_time DATETIME NOT NULL, end_time DATETIME NOT NULL, feedback_type INT NOT NULL, expired_time INT NOT NULL, session_id INT DEFAULT NULL, propagate_neg INT NOT NULL, review_answers INT NOT NULL, random_by_category INT NOT NULL, text_when_finished LONGTEXT DEFAULT NULL, display_category_name INT NOT NULL, pass_percentage INT DEFAULT NULL, autolaunch INT DEFAULT NULL, end_button INT NOT NULL, email_notification_template LONGTEXT DEFAULT NULL, email_notification_template_to_user LONGTEXT DEFAULT NULL, model_type INT DEFAULT NULL, question_selection_type INT DEFAULT NULL, hide_question_title INT DEFAULT NULL, score_type_model INT DEFAULT NULL, global_category_id INT DEFAULT NULL, on_success_message LONGTEXT DEFAULT NULL, on_failed_message LONGTEXT DEFAULT NULL, notify_user_by_email INT DEFAULT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz_rel_category (iid BIGINT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, category_id INT NOT NULL, exercise_id INT NOT NULL, count_questions INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_tool_intro (iid INT AUTO_INCREMENT NOT NULL, id VARCHAR(50) NOT NULL, c_id INT NOT NULL, session_id INT NOT NULL, intro_text LONGTEXT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_attachment (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, path VARCHAR(255) NOT NULL, comment LONGTEXT DEFAULT NULL, size INT NOT NULL, post_id INT NOT NULL, filename VARCHAR(255) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_lp_category (iid INT AUTO_INCREMENT NOT NULL, id INT NOT NULL, c_id INT NOT NULL, name VARCHAR(255) NOT NULL, position INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog_task (iid INT AUTO_INCREMENT NOT NULL, task_id INT NOT NULL, c_id INT NOT NULL, blog_id INT NOT NULL, title VARCHAR(250) NOT NULL, description LONGTEXT NOT NULL, color VARCHAR(10) NOT NULL, system_task TINYINT(1) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_wiki_conf (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, page_id INT NOT NULL, task LONGTEXT NOT NULL, feedback1 LONGTEXT NOT NULL, feedback2 LONGTEXT NOT NULL, feedback3 LONGTEXT NOT NULL, fprogress1 VARCHAR(3) NOT NULL, fprogress2 VARCHAR(3) NOT NULL, fprogress3 VARCHAR(3) NOT NULL, max_size INT DEFAULT NULL, max_text INT DEFAULT NULL, max_version INT DEFAULT NULL, startdate_assig DATETIME NOT NULL, enddate_assig DATETIME NOT NULL, delayedsubmit INT NOT NULL, INDEX page_id (page_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_attendance_sheet (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, user_id INT NOT NULL, attendance_calendar_id INT NOT NULL, presence TINYINT(1) NOT NULL, INDEX presence (presence), UNIQUE INDEX c_id (c_id, user_id, attendance_calendar_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_calendar_event_repeat (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, cal_id INT NOT NULL, cal_type VARCHAR(20) DEFAULT NULL, cal_end INT DEFAULT NULL, cal_frequency INT DEFAULT NULL, cal_days VARCHAR(7) DEFAULT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_calendar_event_repeat_not (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, cal_id INT NOT NULL, cal_date INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_calendar_event_attachment (iid INT AUTO_INCREMENT NOT NULL, id INT NOT NULL, c_id INT NOT NULL, path VARCHAR(255) NOT NULL, comment LONGTEXT DEFAULT NULL, size INT NOT NULL, agenda_id INT NOT NULL, filename VARCHAR(255) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_student_publication_rel_document (iid INT AUTO_INCREMENT NOT NULL, work_id INT NOT NULL, document_id INT NOT NULL, c_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz_answer (iid BIGINT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, question_id INT NOT NULL, answer LONGTEXT NOT NULL, correct INT DEFAULT NULL, comment LONGTEXT DEFAULT NULL, ponderation DOUBLE PRECISION NOT NULL, position INT NOT NULL, hotspot_coordinates LONGTEXT DEFAULT NULL, hotspot_type VARCHAR(100) DEFAULT NULL, destination LONGTEXT NOT NULL, answer_code VARCHAR(10) DEFAULT NULL, INDEX idx_cqa_qid (question_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_category (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, cat_id INT NOT NULL, cat_title VARCHAR(255) NOT NULL, cat_comment LONGTEXT DEFAULT NULL, cat_order INT NOT NULL, locked INT NOT NULL, session_id INT NOT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_course_description (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, title VARCHAR(255) DEFAULT NULL, content LONGTEXT DEFAULT NULL, session_id INT DEFAULT NULL, description_type TINYINT(1) NOT NULL, progress INT NOT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz_question_rel_category (iid INT AUTO_INCREMENT NOT NULL, category_id BIGINT NOT NULL, question_id INT NOT NULL, c_id INT NOT NULL, INDEX IDX_A468585C12469DE2 (category_id), INDEX IDX_A468585C1E27F6BF (question_id), INDEX idx_c_q_qst_r_cat_qc (iid, question_id, c_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog_rel_user (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, blog_id INT NOT NULL, user_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_thematic_advance (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, thematic_id INT NOT NULL, attendance_id INT NOT NULL, content LONGTEXT DEFAULT NULL, start_date DATETIME NOT NULL, duration INT NOT NULL, done_advance TINYINT(1) NOT NULL, INDEX thematic_id (thematic_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_attendance_result (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, attendance_id INT NOT NULL, score INT NOT NULL, INDEX attendance_id (attendance_id), INDEX user_id (user_id), UNIQUE INDEX c_id (c_id, id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_document (iid INT AUTO_INCREMENT NOT NULL, id INT NOT NULL, c_id INT NOT NULL, path VARCHAR(255) NOT NULL, comment LONGTEXT DEFAULT NULL, title VARCHAR(255) DEFAULT NULL, filetype VARCHAR(255) NOT NULL, size INT NOT NULL, readonly TINYINT(1) NOT NULL, session_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");

        $queries->addQuery("CREATE TABLE c_item_property (iid INT AUTO_INCREMENT NOT NULL, to_user_id INT DEFAULT NULL, c_id INT NOT NULL, to_group_id INT DEFAULT NULL, id_session INT NOT NULL, id INT NOT NULL, tool VARCHAR(100) NOT NULL, insert_user_id INT NOT NULL, insert_date DATETIME NOT NULL, lastedit_date DATETIME NOT NULL, ref INT NOT NULL, lastedit_type VARCHAR(100) NOT NULL, lastedit_user_id INT NOT NULL, visibility TINYINT(1) NOT NULL, start_visible DATETIME DEFAULT NULL, end_visible DATETIME DEFAULT NULL, INDEX IDX_1D84C18129F6EE60 (to_user_id), INDEX IDX_1D84C18191D79BD3 (c_id), INDEX IDX_1D84C181330D47E9 (to_group_id), INDEX IDX_1D84C181ED97CA4 (id_session), INDEX idx_item_property_toolref (tool, ref), INDEX idx_item_property_tooliuid (tool, insert_user_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");

        $queries->addQuery("CREATE TABLE c_attendance (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, name LONGTEXT NOT NULL, description LONGTEXT DEFAULT NULL, active TINYINT(1) NOT NULL, attendance_qualify_title VARCHAR(255) DEFAULT NULL, attendance_qualify_max INT NOT NULL, attendance_weight DOUBLE PRECISION NOT NULL, session_id INT NOT NULL, locked INT NOT NULL, INDEX session_id (session_id), INDEX active (active), UNIQUE INDEX c_id (c_id, id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_online_connected (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, user_id INT NOT NULL, last_connection DATETIME NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_thematic_plan (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, thematic_id INT NOT NULL, title VARCHAR(255) NOT NULL, description LONGTEXT DEFAULT NULL, description_type INT NOT NULL, INDEX thematic_id (thematic_id, description_type), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_glossary (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, glossary_id INT NOT NULL, name VARCHAR(255) NOT NULL, description LONGTEXT NOT NULL, display_order INT DEFAULT NULL, session_id INT DEFAULT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_lp_iv_interaction (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id BIGINT NOT NULL, order_id INT NOT NULL, lp_iv_id BIGINT NOT NULL, interaction_id VARCHAR(255) NOT NULL, interaction_type VARCHAR(255) NOT NULL, weighting DOUBLE PRECISION NOT NULL, completion_time VARCHAR(16) NOT NULL, correct_responses LONGTEXT NOT NULL, student_response LONGTEXT NOT NULL, result VARCHAR(255) NOT NULL, latency VARCHAR(16) NOT NULL, INDEX lp_iv_id (lp_iv_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_group_rel_tutor (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, group_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_wiki_mailcue (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, type LONGTEXT NOT NULL, group_id INT DEFAULT NULL, session_id INT DEFAULT NULL, INDEX c_id (c_id, id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_survey_question (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, question_id INT NOT NULL, survey_id INT NOT NULL, survey_question LONGTEXT NOT NULL, survey_question_comment LONGTEXT NOT NULL, type VARCHAR(250) NOT NULL, display VARCHAR(10) NOT NULL, sort INT NOT NULL, shared_question_id INT DEFAULT NULL, max_value INT DEFAULT NULL, survey_group_pri INT NOT NULL, survey_group_sec1 INT NOT NULL, survey_group_sec2 INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog_task_rel_user (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, blog_id INT NOT NULL, user_id INT NOT NULL, task_id INT NOT NULL, target_date DATE NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_survey_question_option (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, question_option_id INT NOT NULL, question_id INT NOT NULL, survey_id INT NOT NULL, option_text LONGTEXT NOT NULL, sort INT NOT NULL, value INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_dropbox_feedback (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, feedback_id INT NOT NULL, file_id INT NOT NULL, author_user_id INT NOT NULL, feedback LONGTEXT NOT NULL, feedback_date DATETIME NOT NULL, INDEX file_id (file_id), INDEX author_user_id (author_user_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_thread_qualify_log (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, thread_id INT NOT NULL, qualify DOUBLE PRECISION NOT NULL, qualify_user_id INT DEFAULT NULL, qualify_time DATETIME DEFAULT NULL, session_id INT DEFAULT NULL, INDEX user_id (user_id, thread_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_mailcue (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, thread_id INT NOT NULL, post_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_attendance_sheet_log (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, attendance_id INT NOT NULL, lastedit_date DATETIME NOT NULL, lastedit_type VARCHAR(200) NOT NULL, lastedit_user_id INT NOT NULL, calendar_date_value DATETIME DEFAULT NULL, UNIQUE INDEX c_id (c_id, id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_survey_group (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, name VARCHAR(20) NOT NULL, description VARCHAR(255) NOT NULL, survey_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_dropbox_post (iid INT AUTO_INCREMENT NOT NULL, dest_user_id INT NOT NULL, file_id INT NOT NULL, c_id INT NOT NULL, feedback_date DATETIME NOT NULL, feedback LONGTEXT DEFAULT NULL, cat_id INT NOT NULL, session_id INT NOT NULL, INDEX IDX_9B64EEF17737EAA1 (dest_user_id), INDEX IDX_9B64EEF193CB796C (file_id), INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_online_link (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, name VARCHAR(50) NOT NULL, url VARCHAR(100) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, blog_id INT NOT NULL, blog_name VARCHAR(250) NOT NULL, blog_subtitle VARCHAR(250) DEFAULT NULL, date_creation DATETIME NOT NULL, visibility TINYINT(1) NOT NULL, session_id INT DEFAULT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_student_publication_rel_user (iid INT AUTO_INCREMENT NOT NULL, work_id INT NOT NULL, user_id INT NOT NULL, c_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_post (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, post_id INT NOT NULL, post_title VARCHAR(250) DEFAULT NULL, post_text LONGTEXT DEFAULT NULL, thread_id INT DEFAULT NULL, forum_id INT DEFAULT NULL, poster_id INT DEFAULT NULL, poster_name VARCHAR(100) DEFAULT NULL, post_date DATETIME DEFAULT NULL, post_notification TINYINT(1) DEFAULT NULL, post_parent_id INT DEFAULT NULL, visible TINYINT(1) DEFAULT NULL, INDEX poster_id (poster_id), INDEX forum_id (forum_id), INDEX idx_forum_post_thread_id (thread_id), INDEX idx_forum_post_visible (visible), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_lp_item_view (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id BIGINT NOT NULL, lp_item_id INT NOT NULL, lp_view_id INT NOT NULL, view_count INT NOT NULL, start_time INT NOT NULL, total_time INT NOT NULL, score DOUBLE PRECISION NOT NULL, status VARCHAR(32) NOT NULL, suspend_data LONGTEXT DEFAULT NULL, lesson_location LONGTEXT DEFAULT NULL, core_exit VARCHAR(32) NOT NULL, max_score VARCHAR(8) DEFAULT NULL, INDEX lp_item_id (lp_item_id), INDEX lp_view_id (lp_view_id), INDEX idx_c_lp_item_view_cid_lp_view_id_lp_item_id (c_id, lp_view_id, lp_item_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_student_publication (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, url VARCHAR(255) DEFAULT NULL, title VARCHAR(255) DEFAULT NULL, filename VARCHAR(255) DEFAULT NULL, description LONGTEXT DEFAULT NULL, author VARCHAR(255) DEFAULT NULL, active TINYINT(1) DEFAULT NULL, accepted TINYINT(1) DEFAULT NULL, post_group_id INT NOT NULL, sent_date DATETIME NOT NULL, filetype VARCHAR(255) NOT NULL, has_properties INT NOT NULL, view_properties TINYINT(1) DEFAULT NULL, qualification DOUBLE PRECISION NOT NULL, date_of_qualification DATETIME NOT NULL, parent_id INT NOT NULL, qualificator_id INT NOT NULL, weight DOUBLE PRECISION NOT NULL, session_id INT NOT NULL, user_id INT NOT NULL, allow_text_assignment INT NOT NULL, contains_file INT NOT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog_comment (iid INT AUTO_INCREMENT NOT NULL, comment_id INT NOT NULL, c_id INT NOT NULL, title VARCHAR(250) NOT NULL, comment LONGTEXT NOT NULL, author_id INT NOT NULL, date_creation DATETIME NOT NULL, blog_id INT NOT NULL, post_id INT NOT NULL, task_id INT DEFAULT NULL, parent_comment_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_forum_thread (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, thread_id INT NOT NULL, thread_title VARCHAR(255) DEFAULT NULL, forum_id INT DEFAULT NULL, thread_replies INT DEFAULT NULL, thread_poster_id INT DEFAULT NULL, thread_poster_name VARCHAR(100) DEFAULT NULL, thread_views INT DEFAULT NULL, thread_last_post INT DEFAULT NULL, thread_date DATETIME DEFAULT NULL, thread_sticky TINYINT(1) DEFAULT NULL, locked INT NOT NULL, session_id INT DEFAULT NULL, thread_title_qualify VARCHAR(255) DEFAULT NULL, thread_qualify_max DOUBLE PRECISION NOT NULL, thread_close_date DATETIME DEFAULT NULL, thread_weight DOUBLE PRECISION NOT NULL, INDEX idx_forum_thread_forum_id (forum_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_permission_group (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, group_id INT NOT NULL, tool VARCHAR(250) NOT NULL, action VARCHAR(250) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_survey_invitation (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, survey_invitation_id INT NOT NULL, survey_code VARCHAR(20) NOT NULL, user VARCHAR(250) NOT NULL, invitation_code VARCHAR(250) NOT NULL, invitation_date DATETIME NOT NULL, reminder_date DATETIME NOT NULL, answered INT NOT NULL, session_id INT NOT NULL, group_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_blog_attachment (iid INT AUTO_INCREMENT NOT NULL, id INT DEFAULT NULL, c_id INT NOT NULL, path VARCHAR(255) NOT NULL, comment LONGTEXT DEFAULT NULL, size INT NOT NULL, post_id INT NOT NULL, filename VARCHAR(255) NOT NULL, blog_id INT NOT NULL, comment_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_tool (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, name VARCHAR(255) NOT NULL, link VARCHAR(255) NOT NULL, image VARCHAR(255) DEFAULT NULL, custom_icon VARCHAR(255) DEFAULT NULL, visibility TINYINT(1) DEFAULT NULL, admin VARCHAR(255) DEFAULT NULL, address VARCHAR(255) DEFAULT NULL, added_tool TINYINT(1) DEFAULT NULL, target VARCHAR(255) NOT NULL, category VARCHAR(20) NOT NULL, session_id INT DEFAULT NULL, description LONGTEXT DEFAULT NULL, INDEX IDX_8456658091D79BD3 (c_id), INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_link (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, url LONGTEXT NOT NULL, title VARCHAR(150) DEFAULT NULL, description LONGTEXT DEFAULT NULL, category_id INT DEFAULT NULL, display_order INT NOT NULL, on_homepage VARCHAR(100) NOT NULL, target VARCHAR(10) DEFAULT NULL, session_id INT DEFAULT NULL, INDEX session_id (session_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_quiz_question_option (iid BIGINT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, question_id INT NOT NULL, name VARCHAR(255) DEFAULT NULL, position INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_student_publication_assignment (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, expires_on DATETIME NOT NULL, ends_on DATETIME NOT NULL, add_to_calendar TINYINT(1) NOT NULL, enable_qualification TINYINT(1) NOT NULL, publication_id INT NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_attendance_calendar (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, attendance_id INT NOT NULL, date_time DATETIME NOT NULL, done_attendance TINYINT(1) NOT NULL, INDEX attendance_id (attendance_id), INDEX done_attendance (done_attendance), UNIQUE INDEX c_id (c_id, id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_permission_user (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, id INT NOT NULL, user_id INT NOT NULL, tool VARCHAR(250) NOT NULL, action VARCHAR(250) NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_student_publication_comment (iid INT AUTO_INCREMENT NOT NULL, work_id INT NOT NULL, c_id INT NOT NULL, comment LONGTEXT DEFAULT NULL, user_id INT NOT NULL, sent_at DATETIME NOT NULL, PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("CREATE TABLE c_chat_connected (iid INT AUTO_INCREMENT NOT NULL, c_id INT NOT NULL, user_id INT NOT NULL, last_connection DATETIME NOT NULL, session_id INT NOT NULL, to_group_id INT NOT NULL, INDEX char_connected_index (user_id, session_id, to_group_id), PRIMARY KEY(iid)) DEFAULT CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE = InnoDB");
        $queries->addQuery("ALTER TABLE c_dropbox_file ADD CONSTRAINT FK_4D71B46C16678C77 FOREIGN KEY (uploader_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE c_quiz_category ADD CONSTRAINT FK_2AF3F510727ACA70 FOREIGN KEY (parent_id) REFERENCES c_quiz_category (iid) ON DELETE SET NULL");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category ADD CONSTRAINT FK_A468585C12469DE2 FOREIGN KEY (category_id) REFERENCES c_quiz_category (iid)");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category ADD CONSTRAINT FK_A468585C1E27F6BF FOREIGN KEY (question_id) REFERENCES c_quiz_question (iid)");
        $queries->addQuery("ALTER TABLE c_item_property ADD CONSTRAINT FK_1D84C18129F6EE60 FOREIGN KEY (to_user_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE c_item_property ADD CONSTRAINT FK_1D84C18191D79BD3 FOREIGN KEY (c_id) REFERENCES course (id)");
        $queries->addQuery("ALTER TABLE c_item_property ADD CONSTRAINT FK_1D84C181330D47E9 FOREIGN KEY (to_group_id) REFERENCES c_group_info (iid)");
        $queries->addQuery("ALTER TABLE c_item_property ADD CONSTRAINT FK_1D84C181ED97CA4 FOREIGN KEY (id_session) REFERENCES session (id)");
        $queries->addQuery("ALTER TABLE c_dropbox_post ADD CONSTRAINT FK_9B64EEF17737EAA1 FOREIGN KEY (dest_user_id) REFERENCES user (id)");
        $queries->addQuery("ALTER TABLE c_dropbox_post ADD CONSTRAINT FK_9B64EEF193CB796C FOREIGN KEY (file_id) REFERENCES c_dropbox_file (iid)");
        $queries->addQuery("ALTER TABLE c_tool ADD CONSTRAINT FK_8456658091D79BD3 FOREIGN KEY (c_id) REFERENCES course (id)");
        $queries->addQuery("ALTER TABLE c_tool DROP FOREIGN KEY FK_8456658091D79BD3");
        $queries->addQuery("ALTER TABLE c_item_property DROP FOREIGN KEY FK_1D84C181ED97CA4");
        $queries->addQuery("ALTER TABLE c_dropbox_post DROP FOREIGN KEY FK_9B64EEF193CB796C");
        $queries->addQuery("ALTER TABLE c_quiz_category DROP FOREIGN KEY FK_2AF3F510727ACA70");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category DROP FOREIGN KEY FK_A468585C12469DE2");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category DROP FOREIGN KEY FK_A468585C1E27F6BF");
        $queries->addQuery("ALTER TABLE c_item_property DROP FOREIGN KEY FK_1D84C181330D47E9");
        $queries->addQuery("ALTER TABLE c_quiz_category ADD CONSTRAINT FK_2AF3F510727ACA70 FOREIGN KEY (parent_id) REFERENCES c_quiz_category (iid) ON DELETE SET NULL");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category ADD CONSTRAINT FK_A468585C12469DE2 FOREIGN KEY (category_id) REFERENCES c_quiz_category (iid)");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category ADD CONSTRAINT FK_A468585C1E27F6BF FOREIGN KEY (question_id) REFERENCES c_quiz_question (iid)");
        $queries->addQuery("ALTER TABLE c_item_property ADD CONSTRAINT FK_1D84C181330D47E9 FOREIGN KEY (to_group_id) REFERENCES c_group_info (iid)");
        $queries->addQuery("ALTER TABLE c_item_property ADD CONSTRAINT FK_1D84C181ED97CA4 FOREIGN KEY (id_session) REFERENCES session (id)");
        $queries->addQuery("ALTER TABLE c_dropbox_post ADD CONSTRAINT FK_9B64EEF193CB796C FOREIGN KEY (file_id) REFERENCES c_dropbox_file (iid)");
        $queries->addQuery("ALTER TABLE c_tool ADD CONSTRAINT FK_8456658091D79BD3 FOREIGN KEY (c_id) REFERENCES course (id)");

        $queries->addQuery("ALTER TABLE course_rel_user ADD CONSTRAINT FK_92CFD9FEFE54D947 FOREIGN KEY (group_id) REFERENCES c_group_info (iid)");
        $queries->addQuery("ALTER TABLE question_field_values ADD CONSTRAINT FK_83093BA61E27F6BF FOREIGN KEY (question_id) REFERENCES c_quiz_question (iid)");
    }

    public function down(Schema $schema, QueryBag $queries)
    {
        $queries->addQuery("ALTER TABLE c_dropbox_file DROP FOREIGN KEY FK_4D71B46C16678C77");
        $queries->addQuery("ALTER TABLE c_item_property DROP FOREIGN KEY FK_1D84C18129F6EE60");
        $queries->addQuery("ALTER TABLE c_dropbox_post DROP FOREIGN KEY FK_9B64EEF17737EAA1");
        $queries->addQuery("ALTER TABLE c_item_property DROP FOREIGN KEY FK_1D84C18191D79BD3");
        $queries->addQuery("ALTER TABLE c_dropbox_post DROP FOREIGN KEY FK_9B64EEF193CB796C");
        $queries->addQuery("ALTER TABLE c_item_property DROP FOREIGN KEY FK_1D84C181330D47E9");
        $queries->addQuery("ALTER TABLE c_item_property DROP FOREIGN KEY FK_1D84C181ED97CA4");
        $queries->addQuery("ALTER TABLE c_quiz_category DROP FOREIGN KEY FK_2AF3F510727ACA70");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category DROP FOREIGN KEY FK_A468585C12469DE2");
        $queries->addQuery("ALTER TABLE c_quiz_question_rel_category DROP FOREIGN KEY FK_A468585C1E27F6BF");
        $queries->addQuery("ALTER TABLE c_tool DROP FOREIGN KEY FK_8456658091D79BD3");
        $queries->addQuery("ALTER TABLE course_rel_user DROP FOREIGN KEY FK_92CFD9FEFE54D947");
        $queries->addQuery("ALTER TABLE question_field_values DROP FOREIGN KEY FK_83093BA61E27F6BF");

        $queries->addQuery("DROP TABLE c_forum_notification");
        $queries->addQuery("DROP TABLE c_wiki");
        $queries->addQuery("DROP TABLE c_course_setting");
        $queries->addQuery("DROP TABLE c_permission_task");
        $queries->addQuery("DROP TABLE c_dropbox_category");
        $queries->addQuery("DROP TABLE c_wiki_discuss");
        $queries->addQuery("DROP TABLE c_dropbox_file");
        $queries->addQuery("DROP TABLE c_quiz_rel_question");
        $queries->addQuery("DROP TABLE c_calendar_event");
        $queries->addQuery("DROP TABLE c_blog_rating");
        $queries->addQuery("DROP TABLE c_quiz_category");
        $queries->addQuery("DROP TABLE c_thematic");
        $queries->addQuery("DROP TABLE c_survey");
        $queries->addQuery("DROP TABLE c_announcement_attachment");
        $queries->addQuery("DROP TABLE c_lp");
        $queries->addQuery("DROP TABLE c_quiz_order");
        $queries->addQuery("DROP TABLE c_lp_iv_objective");
        $queries->addQuery("DROP TABLE c_dropbox_person");
        $queries->addQuery("DROP TABLE c_announcement");
        $queries->addQuery("DROP TABLE c_survey_answer");
        $queries->addQuery("DROP TABLE c_forum_thread_qualify");
        $queries->addQuery("DROP TABLE c_blog_post");
        $queries->addQuery("DROP TABLE c_group_category");
        $queries->addQuery("DROP TABLE c_forum_forum");
        $queries->addQuery("DROP TABLE c_lp_item");
        $queries->addQuery("DROP TABLE c_group_rel_user");
        $queries->addQuery("DROP TABLE c_lp_view");
        $queries->addQuery("DROP TABLE c_link_category");
        $queries->addQuery("DROP TABLE c_quiz");
        $queries->addQuery("DROP TABLE c_quiz_rel_category");
        $queries->addQuery("DROP TABLE c_tool_intro");
        $queries->addQuery("DROP TABLE c_forum_attachment");
        $queries->addQuery("DROP TABLE c_lp_category");
        $queries->addQuery("DROP TABLE c_blog_task");
        $queries->addQuery("DROP TABLE c_wiki_conf");
        $queries->addQuery("DROP TABLE c_attendance_sheet");
        $queries->addQuery("DROP TABLE c_calendar_event_repeat");
        $queries->addQuery("DROP TABLE c_calendar_event_repeat_not");
        $queries->addQuery("DROP TABLE c_calendar_event_attachment");
        $queries->addQuery("DROP TABLE c_student_publication_rel_document");
        $queries->addQuery("DROP TABLE c_quiz_answer");
        $queries->addQuery("DROP TABLE c_forum_category");
        $queries->addQuery("DROP TABLE c_course_description");
        $queries->addQuery("DROP TABLE c_quiz_question_rel_category");
        $queries->addQuery("DROP TABLE c_blog_rel_user");
        $queries->addQuery("DROP TABLE c_thematic_advance");
        $queries->addQuery("DROP TABLE c_attendance_result");
        $queries->addQuery("DROP TABLE c_document");
        $queries->addQuery("DROP TABLE c_item_property");
        $queries->addQuery("DROP TABLE c_attendance");
        $queries->addQuery("DROP TABLE c_online_connected");
        $queries->addQuery("DROP TABLE c_thematic_plan");
        $queries->addQuery("DROP TABLE c_glossary");
        $queries->addQuery("DROP TABLE c_lp_iv_interaction");
        $queries->addQuery("DROP TABLE c_group_rel_tutor");
        $queries->addQuery("DROP TABLE c_wiki_mailcue");
        $queries->addQuery("DROP TABLE c_survey_question");
        $queries->addQuery("DROP TABLE c_blog_task_rel_user");
        $queries->addQuery("DROP TABLE c_survey_question_option");
        $queries->addQuery("DROP TABLE c_dropbox_feedback");
        $queries->addQuery("DROP TABLE c_forum_thread_qualify_log");
        $queries->addQuery("DROP TABLE c_forum_mailcue");
        $queries->addQuery("DROP TABLE c_attendance_sheet_log");
        $queries->addQuery("DROP TABLE c_survey_group");
        $queries->addQuery("DROP TABLE c_dropbox_post");
        $queries->addQuery("DROP TABLE c_online_link");
        $queries->addQuery("DROP TABLE c_blog");
        $queries->addQuery("DROP TABLE c_student_publication_rel_user");
        $queries->addQuery("DROP TABLE c_forum_post");
        $queries->addQuery("DROP TABLE c_lp_item_view");
        $queries->addQuery("DROP TABLE c_student_publication");
        $queries->addQuery("DROP TABLE c_blog_comment");
        $queries->addQuery("DROP TABLE c_forum_thread");
        $queries->addQuery("DROP TABLE c_permission_group");
        $queries->addQuery("DROP TABLE c_survey_invitation");
        $queries->addQuery("DROP TABLE c_blog_attachment");
        $queries->addQuery("DROP TABLE c_tool");
        $queries->addQuery("DROP TABLE c_link");
        $queries->addQuery("DROP TABLE c_quiz_question_option");
        $queries->addQuery("DROP TABLE c_student_publication_assignment");
        $queries->addQuery("DROP TABLE c_attendance_calendar");
        $queries->addQuery("DROP TABLE c_permission_user");
        $queries->addQuery("DROP TABLE c_student_publication_comment");
        $queries->addQuery("DROP TABLE c_chat_connected");
        $queries->addQuery("DROP TABLE c_group_info");
    }
}
